/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      return 0;

    case ZERO_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      return 1;

    case ASHIFT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[1] = x6;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              x7 = XEXP (x3, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  || !register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || GET_MODE (x3) != E_HImode
                  || GET_MODE (x5) != E_HImode)
                return -1;
              x8 = XEXP (x2, 1);
              operands[2] = x8;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 2;

            case AND:
              res = pattern2 (x2);
              if (res >= 0)
                return res + 3; /* [3, 8] */
              return -1;

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != AND)
            return -1;
          res = pattern2 (x2);
          if (res >= 0)
            return res + 9; /* [9, 14] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      res = pattern3 (x2);
      if (res >= 0)
        return res + 15; /* [15, 20] */
      return -1;

    case LSHIFTRT:
      res = pattern5 (x1);
      if (res >= 0)
        return res + 21; /* [21, 30] */
      return -1;

    case ASHIFTRT:
      res = pattern5 (x1);
      if (res >= 0)
        return res + 31; /* [31, 40] */
      return -1;

    case GE:
      res = pattern8 (x1);
      if (res >= 0)
        return res + 41; /* [41, 56] */
      return -1;

    case LT:
      res = pattern8 (x1);
      if (res >= 0)
        return res + 57; /* [57, 72] */
      return -1;

    case MULT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          return 73;

        case SIGN_EXTEND:
          return 74;

        case ZERO_EXTEND:
          return 75;

        case AND:
          return 76;

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTRACT:
          res = pattern11 (x2);
          if (res >= 0)
            return res + 77; /* [77, 92] */
          return -1;

        case ASHIFT:
          res = pattern12 (x2);
          if (res >= 0)
            return res + 93; /* [93, 95] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      if (!const_8_16_24_operand (operands[3], E_QImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          return pattern45 (x3, 
E_HImode); /* [-1, 0] */

        case E_PSImode:
          if (pattern45 (x3, 
E_PSImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern45 (x3, 
E_SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x8 = XEXP (x5, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          res = pattern47 (x3);
          if (res >= 0)
            return res + 3; /* [3, 8] */
          return -1;

        case AND:
          res = pattern2 (x3);
          if (res >= 0)
            return res + 9; /* [9, 14] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x8 = XEXP (x5, 0);
      if (GET_CODE (x8) != AND)
        return -1;
      res = pattern2 (x3);
      if (res >= 0)
        return res + 15; /* [15, 20] */
      return -1;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x7 = XEXP (x4, 2);
  operands[1] = x7;
  if (!const_0_to_7_operand (operands[1], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[3] = x9;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (REGNO (x3) != 10)
    return -1;
  x4 = XEXP (x1, 0);
  switch (GET_MODE (x4))
    {
    case E_DImode:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_DQmode:
      if (GET_MODE (x2) != E_DQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DQmode
          || GET_MODE (x3) != E_DQmode)
        return -1;
      return 1;

    case E_UDQmode:
      if (GET_MODE (x2) != E_UDQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDQmode
          || GET_MODE (x3) != E_UDQmode)
        return -1;
      return 2;

    case E_DAmode:
      if (GET_MODE (x2) != E_DAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DAmode
          || GET_MODE (x3) != E_DAmode)
        return -1;
      return 3;

    case E_UDAmode:
      if (GET_MODE (x2) != E_UDAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDAmode
          || GET_MODE (x3) != E_UDAmode)
        return -1;
      return 4;

    case E_TAmode:
      if (GET_MODE (x2) != E_TAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_TAmode
          || GET_MODE (x3) != E_TAmode)
        return -1;
      return 5;

    case E_UTAmode:
      if (GET_MODE (x2) != E_UTAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UTAmode
          || GET_MODE (x3) != E_UTAmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern82 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[2] = x1;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          return pattern84 (x1, 
E_QImode); /* [-1, 0] */

        case E_HImode:
          if (pattern84 (x1, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_PSImode:
          if (pattern84 (x1, 
E_PSImode) != 0)
            return -1;
          return 2;

        case E_SImode:
          if (pattern84 (x1, 
E_SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern86 (x1);
      if (res >= 0)
        return res + 4; /* [4, 9] */
      return -1;

    case ZERO_EXTEND:
      res = pattern86 (x1);
      if (res >= 0)
        return res + 10; /* [10, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern94 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!reg_or_low_io_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x2, 2);
  operands[2] = x6;
  if (!const_0_to_7_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern100 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != i2)
    return -1;
  return 0;
}

int
pattern104 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LO_SUM
      || GET_MODE (x3) != E_PSImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 21
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 22)
    return -1;
  return 0;
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode
      || !register_operand (operands[1], E_PSImode)
      || !nonmemory_operand (operands[2], E_QImode)
      || !scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern117 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 24
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 24
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 26
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  return pattern116 (x8); /* [-1, 0] */
}

int
pattern127 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode)
          || pattern126 (x1) != 0)
        return -1;
      return 0;

    case AND:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      res = pattern85 (x1);
      if (res >= 0)
        return res + 1; /* [1, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern132 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern132 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern132 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern132 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 2);
  operands[2] = x4;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern135 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern135 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern135 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern135 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern142 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern148 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (REGNO (x7))
    {
    case 24:
      if (REGNO (x3) != 24)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_HQmode:
          if (GET_MODE (x6) != E_HQmode
              || GET_MODE (x7) != E_HQmode)
            return -1;
          return 0;

        case E_HAmode:
          if (GET_MODE (x6) != E_HAmode
              || GET_MODE (x7) != E_HAmode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 22:
      if (REGNO (x3) != 22)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SAmode:
          if (GET_MODE (x6) != E_SAmode
              || GET_MODE (x7) != E_SAmode)
            return -1;
          return 2;

        case E_SQmode:
          if (GET_MODE (x6) != E_SQmode
              || GET_MODE (x7) != E_SQmode)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern163 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 26
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x2, 1);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 18
      || GET_MODE (x7) != E_SImode
      || pattern162 (x1, 
E_SImode, 
22) != 0)
    return -1;
  return 0;
}

int
pattern168 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x5, 1);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x5) != E_QImode
          || GET_MODE (x6) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x5) != E_HImode
          || GET_MODE (x6) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x5) != E_PSImode
          || GET_MODE (x6) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x5) != E_SImode
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern184 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 1);
  operands[1] = x9;
  x10 = XEXP (x8, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x8) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x8) != E_PSImode
          || !register_operand (operands[1], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x8) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern196 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!pseudo_register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!pseudo_register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!pseudo_register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern201 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 18
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XEXP (x3, 1);
  if (XWINT (x9, 0) != 16L
      || pattern162 (x1, 
E_HImode, 
24) != 0)
    return -1;
  return 0;
}

int
pattern207 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != E_CCZNmode
      || GET_MODE (x3) != E_CCZNmode)
    return -1;
  x9 = XEXP (x4, 0);
  operands[3] = x9;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  x10 = XEXP (x4, 1);
  operands[4] = x10;
  if (!nonmemory_operand (operands[4], E_QImode))
    return -1;
  x11 = XEXP (x6, 0);
  operands[0] = x11;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x12 = XEXP (x7, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x13 = XEXP (x7, 1);
  operands[2] = x13;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern225 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern231 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode
      || GET_MODE (x2) != E_QImode)
    return -1;
  return 0;
}

int
pattern236 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      return pattern108 (x1, 
E_QQmode); /* [-1, 0] */

    case E_HQmode:
      if (pattern108 (x1, 
E_HQmode) != 0)
        return -1;
      return 1;

    case E_HAmode:
      if (pattern108 (x1, 
E_HAmode) != 0)
        return -1;
      return 2;

    case E_SAmode:
      if (pattern108 (x1, 
E_SAmode) != 0)
        return -1;
      return 3;

    case E_SQmode:
      if (pattern108 (x1, 
E_SQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern242 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 0);
  switch (REGNO (x6))
    {
    case 24:
      switch (REGNO (x4))
        {
        case 22:
          return 0;

        case 18:
          return 1;

        default:
          return -1;
        }

    case 22:
      if (GET_MODE (x6) != E_SImode
          || REGNO (x4) != 18
          || GET_MODE (x4) != E_SImode
          || REGNO (x5) != 18
          || GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 22
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 18
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 22
          || GET_MODE (x11) != E_SImode
          || pattern240 (x1, 
E_SImode, 
E_HImode, 
30, 
26) != 0)
        return -1;
      return 2;

    case 26:
      if (REGNO (x4) != 22
          || REGNO (x5) != 24)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 26
          || GET_MODE (x11) != E_HImode)
        return -1;
      x12 = XVECEXP (x1, 0, 2);
      x13 = XEXP (x12, 0);
      if (REGNO (x13) != 21
          || GET_MODE (x13) != E_QImode)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      if (REGNO (x15) != 36
          || GET_MODE (x15) != E_CCmode)
        return -1;
      res = pattern241 (x2);
      if (res >= 0)
        return res + 3; /* [3, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern258 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x5;
      return 0;

    case SIGN_EXTEND:
      res = pattern257 (x5);
      if (res >= 0)
        return res + 1; /* [1, 6] */
      return -1;

    case ZERO_EXTEND:
      res = pattern257 (x5);
      if (res >= 0)
        return res + 7; /* [7, 12] */
      return -1;

    default:
      return -1;
    }
}

int
pattern266 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  switch (REGNO (x7))
    {
    case 22:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x5, 1);
      x9 = XEXP (x8, 0);
      if (REGNO (x9) != 24
          || GET_MODE (x9) != E_QImode
          || pattern265 (x1, 
E_HImode, 
22, 
E_QImode, 
21, 
24) != 0)
        return -1;
      return 0;

    case 18:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x5, 1);
      x9 = XEXP (x8, 0);
      if (REGNO (x9) != 22
          || GET_MODE (x9) != E_SImode
          || pattern265 (x1, 
E_DImode, 
30, 
E_HImode, 
26, 
18) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern276 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  return pattern241 (x4); /* [-1, 3] */
}

int
pattern281 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (REGNO (x5) != 22
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (REGNO (x6) != 24
      || GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (REGNO (x8) != 22
      || GET_MODE (x8) != E_QImode
      || GET_MODE (x3) != E_QImode)
    return -1;
  return 0;
}

int
pattern290 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18)
    return -1;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_DImode:
      if (!const_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_DQmode:
      if (!const_operand (operands[1], E_DQmode))
        return -1;
      return 1;

    case E_UDQmode:
      if (!const_operand (operands[1], E_UDQmode))
        return -1;
      return 2;

    case E_DAmode:
      if (!const_operand (operands[1], E_DAmode))
        return -1;
      return 3;

    case E_UDAmode:
      if (!const_operand (operands[1], E_UDAmode))
        return -1;
      return 4;

    case E_TAmode:
      if (!const_operand (operands[1], E_TAmode))
        return -1;
      return 5;

    case E_UTAmode:
      if (!const_operand (operands[1], E_UTAmode))
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern298 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != SIGN_EXTEND
      || pattern297 (x4, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern303 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !pseudo_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  return pattern270 (x4); /* [-1, 3] */
}

int
pattern309 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern314 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 36
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern318 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  return pattern317 (x1); /* [-1, 9] */
}

int
pattern322 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern327 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !d_register_operand (operands[1], i1)
      || XVECLEN (x1, 0) != 3)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x3, 0);
  operands[3] = x7;
  if (!d_register_operand (operands[3], E_QImode))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  switch (GET_CODE (x6))
    {
    case PLUS:
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!const_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 0;

    case IOR:
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!const_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 1;

    case AND:
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!const_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern341 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  switch (REGNO (x7))
    {
    case 22:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XVECEXP (x1, 0, 3);
      x9 = XEXP (x8, 0);
      if (REGNO (x9) != 23
          || GET_MODE (x9) != E_QImode)
        return -1;
      x10 = XVECEXP (x1, 0, 4);
      x11 = XEXP (x10, 0);
      if (REGNO (x11) != 24
          || GET_MODE (x11) != E_QImode)
        return -1;
      x12 = XVECEXP (x1, 0, 5);
      x13 = XEXP (x12, 0);
      if (REGNO (x13) != 25
          || GET_MODE (x13) != E_QImode
          || pattern140 (x1, 
E_QImode) != 0)
        return -1;
      return 0;

    case 21:
      if (GET_MODE (x7) != E_QImode
          || pattern340 (x1, 
E_HImode, 
26, 
24) != 0)
        return -1;
      return 1;

    case 18:
      if (GET_MODE (x7) != E_SImode
          || pattern340 (x1, 
E_SImode, 
30, 
26) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern356 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i4
      || GET_MODE (x3) != i3)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern361 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (REGNO (x6) != i2
      || GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i3
      || GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (REGNO (x10) != i2
      || GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern371 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (REGNO (x5) != i5
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (REGNO (x6) != i5
      || GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i4
      || GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (REGNO (x10) != i5
      || GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 0);
  if (REGNO (x11) != i4
      || GET_MODE (x11) != i1
      || pattern370 (x1, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern379 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i5
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i4
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i3
      || GET_MODE (x9) != i2
      || pattern142 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern388 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const0_operand (operands[3], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case EQ:
      return pattern387 (x1); /* [-1, 0] */

    case NE:
      if (pattern387 (x1) != 0)
        return -1;
      return 1;

    case GE:
      if (pattern387 (x1) != 0)
        return -1;
      return 2;

    case LT:
      if (pattern387 (x1) != 0)
        return -1;
      return 3;

    case GT:
      if (pattern387 (x1) != 0)
        return -1;
      return 4;

    case LE:
      if (pattern387 (x1) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 2);
  operands[1] = x4;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x6 = XEXP (x2, 0);
  switch (pattern227 (x6))
    {
    case 0:
      return 1076; /* *insv.io */

    case 1:
      return 1078; /* *insv.reg_split */

    default:
      return -1;
    }
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern130 (x2))
        {
        case 0:
          return 246; /* *subhi3.sign_extend.qi_split */

        case 1:
          return 248; /* *subpsi3.sign_extend.qi_split */

        case 2:
          return 252; /* *subpsi3.sign_extend.hi_split */

        case 3:
          return 250; /* *subsi3.sign_extend.qi_split */

        case 4:
          return 254; /* *subsi3.sign_extend.hi_split */

        case 5:
          return 256; /* *subsi3.sign_extend.psi_split */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern130 (x2))
        {
        case 0:
          return 247; /* *subhi3.zero_extend.qi_split */

        case 1:
          return 249; /* *subpsi3.zero_extend.qi_split */

        case 2:
          return 253; /* *subpsi3.zero_extend.hi_split */

        case 3:
          return 251; /* *subsi3.zero_extend.qi_split */

        case 4:
          return 255; /* *subsi3.zero_extend.hi_split */

        case 5:
          return 257; /* *subsi3.zero_extend.psi_split */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_PSImode:
          if (pattern192 (x2, 
E_PSImode) != 0)
            return -1;
          return 272; /* subpsi3 */

        case E_QImode:
          if (pattern213 (x2, 
E_QImode) != 0)
            return -1;
          return 274; /* subqi3 */

        case E_QQmode:
          if (pattern213 (x2, 
E_QQmode) != 0)
            return -1;
          return 275; /* subqq3 */

        case E_UQQmode:
          if (pattern213 (x2, 
E_UQQmode) != 0)
            return -1;
          return 276; /* subuqq3 */

        case E_HImode:
          if (pnum_clobbers == NULL
              || pattern213 (x2, 
E_HImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 280; /* subhi3 */

        case E_HQmode:
          if (pnum_clobbers == NULL
              || pattern213 (x2, 
E_HQmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 281; /* subhq3 */

        case E_UHQmode:
          if (pnum_clobbers == NULL
              || pattern213 (x2, 
E_UHQmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 282; /* subuhq3 */

        case E_HAmode:
          if (pnum_clobbers == NULL
              || pattern213 (x2, 
E_HAmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 283; /* subha3 */

        case E_UHAmode:
          if (pnum_clobbers == NULL
              || pattern213 (x2, 
E_UHAmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 284; /* subuha3 */

        case E_SImode:
          if (pnum_clobbers == NULL
              || pattern213 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 290; /* subsi3 */

        case E_SQmode:
          if (pnum_clobbers == NULL
              || pattern213 (x2, 
E_SQmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 291; /* subsq3 */

        case E_USQmode:
          if (pnum_clobbers == NULL
              || pattern213 (x2, 
E_USQmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 292; /* subusq3 */

        case E_SAmode:
          if (pnum_clobbers == NULL
              || pattern213 (x2, 
E_SAmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 293; /* subsa3 */

        case E_USAmode:
          if (pnum_clobbers == NULL
              || pattern213 (x2, 
E_USAmode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 294; /* subusa3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern131 (x2))
        {
        case 0:
          return 308; /* *subqi3.msbit_split */

        case 1:
          return 310; /* *subhi3.msbit_split */

        case 2:
          return 312; /* *subpsi3.msbit_split */

        case 3:
          return 314; /* *subsi3.msbit_split */

        case 4:
          return 336; /* *subhi3.sex.msbit_split */

        case 5:
          return 338; /* *subpsi3.sex.msbit_split */

        case 6:
          return 342; /* *subpsi3.sex.msbit_split */

        case 7:
          return 340; /* *subsi3.sex.msbit_split */

        case 8:
          return 344; /* *subsi3.sex.msbit_split */

        case 9:
          return 346; /* *subsi3.sex.msbit_split */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern131 (x2))
        {
        case 0:
          return 309; /* *subqi3.msbit_split */

        case 1:
          return 311; /* *subhi3.msbit_split */

        case 2:
          return 313; /* *subpsi3.msbit_split */

        case 3:
          return 315; /* *subsi3.msbit_split */

        case 4:
          return 337; /* *subhi3.sex.msbit_split */

        case 5:
          return 339; /* *subpsi3.sex.msbit_split */

        case 6:
          return 343; /* *subpsi3.sex.msbit_split */

        case 7:
          return 341; /* *subsi3.sex.msbit_split */

        case 8:
          return 345; /* *subsi3.sex.msbit_split */

        case 9:
          return 347; /* *subsi3.sex.msbit_split */

        default:
          return -1;
        }

    case GE:
      switch (pattern133 (x2))
        {
        case 0:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 348; /* *subqi3.ge0 */
            }
          return 444; /* *subqi3.ge0_split */

        case 1:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 356; /* *subqi3.ge0 */
            }
          return 452; /* *subqi3.ge0_split */

        case 2:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 364; /* *subqi3.ge0 */
            }
          return 460; /* *subqi3.ge0_split */

        case 3:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 372; /* *subqi3.ge0 */
            }
          return 468; /* *subqi3.ge0_split */

        case 4:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 350; /* *subhi3.ge0 */
            }
          return 446; /* *subhi3.ge0_split */

        case 5:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 358; /* *subhi3.ge0 */
            }
          return 454; /* *subhi3.ge0_split */

        case 6:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 366; /* *subhi3.ge0 */
            }
          return 462; /* *subhi3.ge0_split */

        case 7:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 374; /* *subhi3.ge0 */
            }
          return 470; /* *subhi3.ge0_split */

        case 8:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 352; /* *subpsi3.ge0 */
            }
          return 448; /* *subpsi3.ge0_split */

        case 9:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 360; /* *subpsi3.ge0 */
            }
          return 456; /* *subpsi3.ge0_split */

        case 10:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 368; /* *subpsi3.ge0 */
            }
          return 464; /* *subpsi3.ge0_split */

        case 11:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 376; /* *subpsi3.ge0 */
            }
          return 472; /* *subpsi3.ge0_split */

        case 12:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 354; /* *subsi3.ge0 */
            }
          return 450; /* *subsi3.ge0_split */

        case 13:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 362; /* *subsi3.ge0 */
            }
          return 458; /* *subsi3.ge0_split */

        case 14:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 370; /* *subsi3.ge0 */
            }
          return 466; /* *subsi3.ge0_split */

        case 15:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 378; /* *subsi3.ge0 */
            }
          return 474; /* *subsi3.ge0_split */

        default:
          return -1;
        }

    case LT:
      switch (pattern133 (x2))
        {
        case 0:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 349; /* *subqi3.lt0 */
            }
          return 445; /* *subqi3.lt0_split */

        case 1:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 357; /* *subqi3.lt0 */
            }
          return 453; /* *subqi3.lt0_split */

        case 2:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 365; /* *subqi3.lt0 */
            }
          return 461; /* *subqi3.lt0_split */

        case 3:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 373; /* *subqi3.lt0 */
            }
          return 469; /* *subqi3.lt0_split */

        case 4:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 351; /* *subhi3.lt0 */
            }
          return 447; /* *subhi3.lt0_split */

        case 5:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 359; /* *subhi3.lt0 */
            }
          return 455; /* *subhi3.lt0_split */

        case 6:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 367; /* *subhi3.lt0 */
            }
          return 463; /* *subhi3.lt0_split */

        case 7:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 375; /* *subhi3.lt0 */
            }
          return 471; /* *subhi3.lt0_split */

        case 8:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 353; /* *subpsi3.lt0 */
            }
          return 449; /* *subpsi3.lt0_split */

        case 9:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 361; /* *subpsi3.lt0 */
            }
          return 457; /* *subpsi3.lt0_split */

        case 10:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 369; /* *subpsi3.lt0 */
            }
          return 465; /* *subpsi3.lt0_split */

        case 11:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 377; /* *subpsi3.lt0 */
            }
          return 473; /* *subpsi3.lt0_split */

        case 12:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 355; /* *subsi3.lt0 */
            }
          return 451; /* *subsi3.lt0_split */

        case 13:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 363; /* *subsi3.lt0 */
            }
          return 459; /* *subsi3.lt0_split */

        case 14:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 371; /* *subsi3.lt0 */
            }
          return 467; /* *subsi3.lt0_split */

        case 15:
          if (pnum_clobbers != NULL
              && 
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 1;
              return 379; /* *subsi3.lt0 */
            }
          return 475; /* *subsi3.lt0_split */

        default:
          return -1;
        }

    case MULT:
      x4 = XEXP (x2, 0);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          if (pattern190 (x2) != 0)
            return -1;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2618 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 492; /* *msubqi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2633 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 493; /* *msubqi4 */

            case CONST_INT:
              if (pnum_clobbers == NULL
                  || !const_int_operand (operands[2], E_QImode)
                  || !
#line 2662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              *pnum_clobbers = 1;
              return 495; /* *msubqi4.const */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern191 (x2) != 0)
            return -1;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x6) != E_HImode)
                return -1;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2730 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 500; /* *msubqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2745 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 502; /* *msubqihi4 */

            case ZERO_EXTEND:
              if (GET_MODE (x6) != E_HImode)
                return -1;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return 509; /* *sumsubqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2811 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              *pnum_clobbers = 1;
              return 511; /* *sumsubqihi4 */

            case CONST_INT:
              if (pnum_clobbers == NULL)
                return -1;
              operands[2] = x6;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2877 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 515; /* *msubqihi4.sconst */
                }
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2968 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              *pnum_clobbers = 1;
              return 520; /* *sumsubqihi4.uconst */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern191 (x2) != 0)
            return -1;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              if (GET_MODE (x6) != E_HImode)
                return -1;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2730 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 501; /* *umsubqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2745 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 503; /* *umsubqihi4 */

            case SIGN_EXTEND:
              if (GET_MODE (x6) != E_HImode)
                return -1;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
                return 508; /* *usmsubqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2811 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
                return -1;
              *pnum_clobbers = 1;
              return 510; /* *usmsubqihi4 */

            case CONST_INT:
              if (pnum_clobbers == NULL)
                return -1;
              operands[2] = x6;
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2877 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              *pnum_clobbers = 1;
              return 516; /* *umsubqihi4.uconst */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return -1;
      x4 = XEXP (x2, 0);
      operands[3] = x4;
      if (!register_operand (operands[3], E_HImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_QImode)
              || !const_2_to_7_operand (operands[2], E_HImode)
              || !
#line 2900 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 517; /* *umsubqihi4.uconst.ashift */

        case SIGN_EXTEND:
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_QImode)
              || !const_1_to_6_operand (operands[2], E_HImode)
              || !
#line 2924 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 518; /* *msubqihi4.sconst.ashift */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      switch (pattern54 (x1, pnum_clobbers))
        {
        case 0:
          return 705; /* ashrqi3 */

        case 1:
          return 706; /* ashrqq3 */

        case 2:
          return 707; /* ashruqq3 */

        case 3:
          if (nop_general_operand (operands[2], E_QImode))
            return 711; /* ashrhi3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 5892 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 733; /* *ashrhi3_const */
            }
          break;

        case 4:
          if (nop_general_operand (operands[2], E_QImode))
            return 712; /* ashrhq3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 5892 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 734; /* *ashrhq3_const */
            }
          break;

        case 5:
          if (nop_general_operand (operands[2], E_QImode))
            return 713; /* ashruhq3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 5892 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 735; /* *ashruhq3_const */
            }
          break;

        case 6:
          if (nop_general_operand (operands[2], E_QImode))
            return 714; /* ashrha3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 5892 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 736; /* *ashrha3_const */
            }
          break;

        case 7:
          if (nop_general_operand (operands[2], E_QImode))
            return 715; /* ashruha3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 5892 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 737; /* *ashruha3_const */
            }
          break;

        case 8:
          *pnum_clobbers = 1;
          return 721; /* ashrpsi3 */

        case 9:
          return 723; /* ashrsi3 */

        case 10:
          return 724; /* ashrsq3 */

        case 11:
          return 725; /* ashrusq3 */

        case 12:
          return 726; /* ashrsa3 */

        case 13:
          return 727; /* ashrusa3 */

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      if (pattern55 (x1) == 0)
        return 1083; /* *insv.shiftrt */
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  switch (pattern56 (x1))
    {
    case 0:
      if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3305; /* ashrdi3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3333; /* *ashrdi3_insn */

    case 1:
      if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3309; /* ashrdq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3337; /* *ashrdq3_insn */

    case 2:
      if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3313; /* ashrudq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3341; /* *ashrudq3_insn */

    case 3:
      if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3317; /* ashrda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3345; /* *ashrda3_insn */

    case 4:
      if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3321; /* ashruda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3349; /* *ashruda3_insn */

    case 5:
      if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3325; /* ashrta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3353; /* *ashrta3_insn */

    case 6:
      if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3329; /* ashruta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3357; /* *ashruta3_insn */

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case MEM:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) == POST_DEC
          && GET_MODE (x3) == E_HImode)
        {
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) == REG
              && REGNO (x4) == 32
              && GET_MODE (x4) == E_HImode)
            {
              x5 = XEXP (x1, 1);
              operands[0] = x5;
              switch (GET_MODE (x2))
                {
                case E_QImode:
                  if (reg_or_0_operand (operands[0], E_QImode))
                    return 1; /* pushqi1 */
                  break;

                case E_QQmode:
                  if (reg_or_0_operand (operands[0], E_QQmode))
                    return 2; /* pushqq1 */
                  break;

                case E_UQQmode:
                  if (reg_or_0_operand (operands[0], E_UQQmode))
                    return 3; /* pushuqq1 */
                  break;

                case E_HImode:
                  if (reg_or_0_operand (operands[0], E_HImode))
                    return 4; /* pushhi1_insn */
                  break;

                default:
                  break;
                }
            }
        }
      break;

    case REG:
    case SUBREG:
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTRACT:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case SUBREG:
    case MEM:
      res = recog_4 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LABEL_REF:
      if (GET_CODE (x2) == PC)
        {
          x6 = XEXP (x5, 0);
          operands[0] = x6;
          return 969; /* jump */
        }
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      operands[0] = x5;
      if (nonmemory_operand (operands[0], E_HImode))
        return 973; /* *indirect_jump */
      break;

    default:
      break;
    }
  operands[0] = x2;
  if (GET_MODE (x5) != E_QImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case SUBREG:
      switch (pattern123 (x5))
        {
        case 0:
          if (register_operand (operands[0], E_QImode))
            return 677; /* *ashlsqihiqi3 */
          if (!memory_operand (operands[0], E_QImode)
              || !
#line 5405 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!reload_completed))
            return -1;
          return 679; /* *ashlsqihiqi3.mem */

        case 1:
          if (register_operand (operands[0], E_QImode))
            return 678; /* *ashluqihiqi3 */
          if (!memory_operand (operands[0], E_QImode)
              || !
#line 5405 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!reload_completed))
            return -1;
          return 680; /* *ashluqihiqi3.mem */

        case 2:
          if (!
#line 5423 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!reload_completed))
            return -1;
          return 681; /* *ashlhiqi3 */

        case 3:
          return 1015; /* mask1_0x80_split */

        case 4:
          if (!
#line 10466 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1157; /* *extzv.subreg.hi */

        case 5:
          if (!
#line 10466 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1158; /* *extzv.subreg.psi */

        case 6:
          if (!
#line 10466 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1159; /* *extzv.subreg.si */

        case 7:
          return 1021; /* *split.flash_segment */

        default:
          return -1;
        }

    case MEM:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != PRE_INC
          || GET_MODE (x6) != E_HImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 32
          || GET_MODE (x7) != E_HImode
          || !register_operand (operands[0], E_QImode))
        return -1;
      return 994; /* popqi */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x3, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x8 = XEXP (x3, 2);
  operands[1] = x8;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x9 = XEXP (x2, 1);
  operands[2] = x9;
  if (!nonmemory_operand (operands[2], E_QImode)
      || !
#line 10013 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
    return -1;
  return 1079; /* *insv.reg */
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x7 = XEXP (x4, 1);
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      if (pattern322 (x1) != 0
          || !
#line 2478 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 480; /* mulqihi3 */

    case ZERO_EXTEND:
      if (pattern322 (x1) != 0
          || !
#line 2526 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 485; /* *sumulqihi3 */

    case CONST_INT:
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      if (s8_operand (operands[2], E_HImode)
          && 
#line 2994 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 521; /* *mulsqihi3.sconst */
      if (u8_operand (operands[2], E_HImode)
          && 
#line 3030 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 524; /* *mulsqihi3.uconst */
      if (!o8_operand (operands[2], E_HImode)
          || !
#line 3048 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 525; /* *mulsqihi3.oconst */

    case REG:
    case SUBREG:
      if (pattern223 (x1) != 0
          || !
#line 3162 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 532; /* *mulsqihi3 */

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (nop_general_operand (operands[2], E_QImode))
    {
      switch (pattern235 (x1))
        {
        case 0:
          if (
#line 5337 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 664; /* *ashlqi3 */
          break;

        case 1:
          if (
#line 5337 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 665; /* *ashlqq3 */
          break;

        case 2:
          if (
#line 5337 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 666; /* *ashluqq3 */
          break;

        case 3:
          if (
#line 5369 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 672; /* *ashlhi3 */
          break;

        case 4:
          if (
#line 5369 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 673; /* *ashlhq3 */
          break;

        case 5:
          if (
#line 5369 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 674; /* *ashluhq3 */
          break;

        case 6:
          if (
#line 5369 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 675; /* *ashlha3 */
          break;

        case 7:
          if (
#line 5369 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 676; /* *ashluha3 */
          break;

        case 8:
          if (
#line 5482 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 687; /* *ashlsi3 */
          break;

        case 9:
          if (
#line 5482 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 688; /* *ashlsq3 */
          break;

        case 10:
          if (
#line 5482 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 689; /* *ashlusq3 */
          break;

        case 11:
          if (
#line 5482 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 690; /* *ashlsa3 */
          break;

        case 12:
          if (
#line 5482 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 691; /* *ashlusa3 */
          break;

        default:
          break;
        }
    }
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_SImode) != 0
          || !
#line 5670 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 697; /* *ashlsi3_const */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_SQmode) != 0
          || !
#line 5670 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 698; /* *ashlsq3_const */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_USQmode) != 0
          || !
#line 5670 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 699; /* *ashlusq3_const */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_SAmode) != 0
          || !
#line 5670 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 700; /* *ashlsa3_const */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_USAmode) != 0
          || !
#line 5670 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 701; /* *ashlusa3_const */

    case E_PSImode:
      if (pattern112 (x4) != 0)
        return -1;
      return 702; /* *ashlpsi3_split */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x3, 0);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  switch (pattern289 (x1))
    {
    case 0:
      return 881; /* cbranchsi4_insn */

    case 1:
      return 882; /* cbranchsq4_insn */

    case 2:
      return 883; /* cbranchusq4_insn */

    case 3:
      return 884; /* cbranchsa4_insn */

    case 4:
      return 885; /* cbranchusa4_insn */

    case 5:
      return 886; /* cbranchpsi4_insn */

    case 6:
      return 887; /* cbranchhi4_insn */

    case 7:
      return 888; /* cbranchhq4_insn */

    case 8:
      return 889; /* cbranchuhq4_insn */

    case 9:
      return 890; /* cbranchha4_insn */

    case 10:
      return 891; /* cbranchuha4_insn */

    default:
      break;
    }
  if (GET_CODE (x9) != REG)
    return -1;
  switch (pattern290 (x1))
    {
    case 0:
      if (!
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
        return -1;
      return 3290; /* cbranch_const_di2_split */

    case 1:
      if (!
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
        return -1;
      return 3291; /* cbranch_const_dq2_split */

    case 2:
      if (!
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
        return -1;
      return 3292; /* cbranch_const_udq2_split */

    case 3:
      if (!
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
        return -1;
      return 3293; /* cbranch_const_da2_split */

    case 4:
      if (!
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
        return -1;
      return 3294; /* cbranch_const_uda2_split */

    case 5:
      if (!
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
        return -1;
      return 3295; /* cbranch_const_ta2_split */

    case 6:
      if (!
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
        return -1;
      return 3296; /* cbranch_const_uta2_split */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[0] = x4;
      if (ordered_comparison_operator (operands[0], E_VOIDmode))
        {
          res = recog_53 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XEXP (x3, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (pattern100 (x9, 
36, 
E_CCmode) != 0)
        return -1;
      switch (GET_CODE (operands[0]))
        {
        case NE:
        case EQ:
          if (!eqne_operator (operands[0], E_VOIDmode))
            return -1;
          x10 = XEXP (x6, 0);
          operands[3] = x10;
          x11 = XEXP (x4, 0);
          switch (GET_CODE (x11))
            {
            case ZERO_EXTRACT:
              x12 = XEXP (x11, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x13 = XEXP (x11, 2);
              operands[2] = x13;
              if (!const_int_operand (operands[2], E_VOIDmode))
                return -1;
              x14 = XEXP (x11, 0);
              switch (GET_CODE (x14))
                {
                case REG:
                case SUBREG:
                  operands[1] = x14;
                  if (!register_operand (operands[1], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (x11))
                    {
                    case E_QImode:
                      if (!
#line 7656 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 953; /* *sbrx_branchqi */

                    case E_HImode:
                      if (!
#line 7656 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 954; /* *sbrx_branchhi */

                    case E_PSImode:
                      if (!
#line 7656 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 955; /* *sbrx_branchpsi */

                    case E_SImode:
                      if (!
#line 7656 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 956; /* *sbrx_branchsi */

                    case E_DImode:
                      if (!
#line 7656 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 957; /* *sbrx_branchdi */

                    default:
                      return -1;
                    }

                case MEM:
                  if (GET_MODE (x14) != E_QImode)
                    return -1;
                  x15 = XEXP (x14, 0);
                  operands[1] = x15;
                  switch (GET_MODE (x11))
                    {
                    case E_QImode:
                      if (low_io_address_operand (operands[1], E_VOIDmode)
                          && 
#line 8170 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                        return 984; /* *sbix_branch */
                      if (!high_io_address_operand (operands[1], E_VOIDmode)
                          || !
#line 8265 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 990; /* *sbix_branch_tmp */

                    case E_HImode:
                      if (low_io_address_operand (operands[1], E_VOIDmode)
                          && 
#line 8170 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                        return 985; /* *sbix_branch */
                      if (!high_io_address_operand (operands[1], E_VOIDmode)
                          || !
#line 8265 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                        return -1;
                      return 991; /* *sbix_branch_tmp */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case AND:
              x14 = XEXP (x11, 0);
              operands[1] = x14;
              x12 = XEXP (x11, 1);
              operands[2] = x12;
              switch (GET_MODE (x11))
                {
                case E_QImode:
                  if (!register_operand (operands[1], E_QImode)
                      || !single_one_operand (operands[2], E_QImode)
                      || !
#line 7704 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 962; /* *sbrx_and_branchqi */

                case E_HImode:
                  if (!register_operand (operands[1], E_HImode)
                      || !single_one_operand (operands[2], E_HImode)
                      || !
#line 7704 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 963; /* *sbrx_and_branchhi */

                case E_PSImode:
                  if (!register_operand (operands[1], E_PSImode)
                      || !single_one_operand (operands[2], E_PSImode)
                      || !
#line 7704 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 964; /* *sbrx_and_branchpsi */

                case E_SImode:
                  if (!register_operand (operands[1], E_SImode)
                      || !single_one_operand (operands[2], E_SImode)
                      || !
#line 7704 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 965; /* *sbrx_and_branchsi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case GE:
        case LT:
          if (!gelt_operator (operands[0], E_VOIDmode))
            return -1;
          x11 = XEXP (x4, 0);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_QImode)
            return -1;
          x14 = XEXP (x11, 0);
          operands[1] = x14;
          x10 = XEXP (x6, 0);
          operands[2] = x10;
          if (low_io_address_operand (operands[1], E_VOIDmode)
              && 
#line 8212 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 987; /* *sbix_branch_bit7 */
          if (!high_io_address_operand (operands[1], E_VOIDmode)
              || !
#line 8306 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 993; /* *sbix_branch_tmp_bit7 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || pattern99 (x1) != 0)
    return -1;
  x5 = XEXP (x3, 2);
  operands[2] = x5;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      switch (pattern333 (x3, 
E_QImode))
        {
        case 0:
          if (!
#line 10662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1232; /* *sextr.qi.qi */

        case 1:
          if (!
#line 10662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1236; /* *sextr.qi.hi */

        case 2:
          if (!
#line 10662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1240; /* *sextr.qi.psi */

        case 3:
          if (!
#line 10662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1244; /* *sextr.qi.si */

        default:
          return -1;
        }

    case E_HImode:
      switch (pattern333 (x3, 
E_HImode))
        {
        case 0:
          if (!
#line 10662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1233; /* *sextr.hi.qi */

        case 1:
          if (!
#line 10662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1237; /* *sextr.hi.hi */

        case 2:
          if (!
#line 10662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1241; /* *sextr.hi.psi */

        case 3:
          if (!
#line 10662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1245; /* *sextr.hi.si */

        default:
          return -1;
        }

    case E_PSImode:
      switch (pattern333 (x3, 
E_PSImode))
        {
        case 0:
          if (!
#line 10662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1234; /* *sextr.psi.qi */

        case 1:
          if (!
#line 10662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1238; /* *sextr.psi.hi */

        case 2:
          if (!
#line 10662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1242; /* *sextr.psi.psi */

        case 3:
          if (!
#line 10662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1246; /* *sextr.psi.si */

        default:
          return -1;
        }

    case E_SImode:
      switch (pattern333 (x3, 
E_SImode))
        {
        case 0:
          if (!
#line 10662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1235; /* *sextr.si.qi */

        case 1:
          if (!
#line 10662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1239; /* *sextr.si.hi */

        case 2:
          if (!
#line 10662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1243; /* *sextr.si.psi */

        case 3:
          if (!
#line 10662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1247; /* *sextr.si.si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_60 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_58 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_56 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_65 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_59 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_68 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_64 (x1, insn, pnum_clobbers);

    case DIV:
      if (pnum_clobbers != NULL)
        {
          switch (pattern141 (x1, 
MOD))
            {
            case 0:
              *pnum_clobbers = 4;
              return 584; /* divmodqi4 */

            case 1:
              *pnum_clobbers = 4;
              return 590; /* divmodhi4 */

            case 2:
              *pnum_clobbers = 2;
              return 606; /* divmodpsi4 */

            case 3:
              *pnum_clobbers = 4;
              return 612; /* divmodsi4 */

            default:
              break;
            }
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern146 (x1, pnum_clobbers, 
MOD))
        {
        case 0:
          *pnum_clobbers = 2;
          return 585; /* *divmodqi4_call_split */

        case 1:
          *pnum_clobbers = 2;
          return 591; /* *divmodhi4_call_split */

        case 2:
          *pnum_clobbers = 3;
          return 607; /* *divmodpsi4_call_split */

        case 3:
          *pnum_clobbers = 2;
          return 613; /* *divmodsi4_call_split */

        case 4:
          return 3095; /* *divqq3.call_split */

        case 5:
          return 3097; /* *divuqq3.call_split */

        default:
          return -1;
        }

    case UDIV:
      if (pnum_clobbers != NULL)
        {
          switch (pattern141 (x1, 
UMOD))
            {
            case 0:
              *pnum_clobbers = 4;
              return 587; /* udivmodqi4 */

            case 1:
              *pnum_clobbers = 4;
              return 593; /* udivmodhi4 */

            case 2:
              *pnum_clobbers = 2;
              return 609; /* udivmodpsi4 */

            case 3:
              *pnum_clobbers = 4;
              return 615; /* udivmodsi4 */

            default:
              break;
            }
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern146 (x1, pnum_clobbers, 
UMOD))
        {
        case 0:
          *pnum_clobbers = 1;
          return 588; /* *udivmodqi4_call_split */

        case 1:
          *pnum_clobbers = 2;
          return 594; /* *udivmodhi4_call_split */

        case 2:
          *pnum_clobbers = 3;
          return 610; /* *udivmodpsi4_call_split */

        case 3:
          *pnum_clobbers = 2;
          return 616; /* *udivmodsi4_call_split */

        case 4:
          return 3094; /* *udivqq3.call_split */

        case 5:
          return 3096; /* *udivuqq3.call_split */

        default:
          return -1;
        }

    case AND:
      return recog_66 (x1, insn, pnum_clobbers);

    case IOR:
      switch (pattern98 (x1, pnum_clobbers))
        {
        case 0:
          if (nonmemory_operand (operands[2], E_QImode)
              && pattern262 (x1, 
E_QImode) == 0
              && 
#line 4643 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 627; /* *iorqi3 */
          x5 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          switch (pattern109 (x3))
            {
            case 0:
              return 628; /* iorhi3 */

            case 1:
              return 630; /* iorpsi3 */

            case 2:
              return 632; /* iorsi3 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 10970 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1477; /* *nzb=1.ior.zerox */

        case 2:
          if (!
#line 11090 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1492; /* *nzb=1.ior.zerox.not */

        default:
          return -1;
        }

    case XOR:
      switch (pattern98 (x1, pnum_clobbers))
        {
        case 0:
          if (register_operand (operands[2], E_QImode)
              && pattern262 (x1, 
E_QImode) == 0
              && 
#line 4767 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 635; /* *xorqi3 */
          x5 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          switch (pattern109 (x3))
            {
            case 0:
              return 636; /* xorhi3 */

            case 1:
              return 638; /* xorpsi3 */

            case 2:
              return 640; /* xorsi3 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 10970 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1476; /* *nzb=1.xor.zerox */

        case 2:
          if (!
#line 11090 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1491; /* *nzb=1.xor.zerox.not */

        default:
          return -1;
        }

    case ROTATE:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          res = recog_48 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (GET_CODE (x4) != REG)
            return -1;
          switch (pattern170 (x1))
            {
            case 0:
              if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3335; /* *rotldi3_insn */

            case 1:
              if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3339; /* *rotldq3_insn */

            case 2:
              if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3343; /* *rotludq3_insn */

            case 3:
              if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3347; /* *rotlda3_insn */

            case 4:
              if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3351; /* *rotluda3_insn */

            case 5:
              if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3355; /* *rotlta3_insn */

            case 6:
              if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3359; /* *rotluta3_insn */

            default:
              return -1;
            }

        case CONST_INT:
          if (pattern169 (x1, 
E_QImode) != 0)
            return -1;
          x7 = XEXP (x3, 1);
          operands[1] = x7;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          switch (XWINT (x4, 0))
            {
            case 1L:
              if (!
#line 8976 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1014; /* *mask1_0x01 */

            case -2L:
              if (!
#line 9052 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1019; /* *mask1_0xfe */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      res = recog_49 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3333; /* *ashrdi3_insn */

        case 1:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3337; /* *ashrdq3_insn */

        case 2:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3341; /* *ashrudq3_insn */

        case 3:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3345; /* *ashrda3_insn */

        case 4:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3349; /* *ashruda3_insn */

        case 5:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3353; /* *ashrta3_insn */

        case 6:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3357; /* *ashruta3_insn */

        default:
          return -1;
        }

    case LSHIFTRT:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      res = recog_50 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3334; /* *lshrdi3_insn */

        case 1:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3338; /* *lshrdq3_insn */

        case 2:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3342; /* *lshrudq3_insn */

        case 3:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3346; /* *lshrda3_insn */

        case 4:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3350; /* *lshruda3_insn */

        case 5:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3354; /* *lshrta3_insn */

        case 6:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3358; /* *lshruta3_insn */

        default:
          return -1;
        }

    case ABS:
      if (pattern99 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 6189 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 782; /* *absqi2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 6209 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 784; /* *abssf2 */

        default:
          return -1;
        }

    case NEG:
      return recog_62 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_63 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_70 (x1, insn, pnum_clobbers);

    case LO_SUM:
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER
          || pattern171 (x1) != 0)
        return -1;
      return 822; /* n_extendhipsi2 */

    case COMPARE:
      return recog_57 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_61 (x1, insn, pnum_clobbers);

    case CALL:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (!nonmemory_operand (operands[1], E_HImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      if (!general_operand (operands[2], E_HImode))
        return -1;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_HImode))
        return -1;
      return 971; /* call_value_insn */

    case ROTATERT:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != CONST_INT
          || XWINT (x4, 0) != -128L)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER
          || pattern209 (x1, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode)
          || !
#line 9009 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1016; /* *mask1_0x80 */

    case PARITY:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      if (REGNO (x6) == 24)
        {
          switch (pattern225 (x1))
            {
            case 0:
              if (
#line 9140 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!reload_completed))
                return 1022; /* *parityhi2 */
              break;

            case 1:
              if (
#line 9169 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!reload_completed))
                return 1024; /* *parityqihi2.2 */
              break;

            default:
              break;
            }
        }
      if (REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24
          || GET_MODE (x4) != E_HImode)
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24
          || GET_MODE (x8) != E_HImode
          || !
#line 9207 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1026; /* *parityhi2.libgcc */

    case ZERO_EXTEND:
      return recog_71 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24)
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern100 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      switch (GET_MODE (x8))
        {
        case E_HImode:
          if (GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_HImode
              || !
#line 9301 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1033; /* *popcounthi2.libgcc */

        case E_QImode:
          if (GET_MODE (x3) != E_QImode
              || GET_MODE (x4) != E_QImode
              || !
#line 9337 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1037; /* *popcountqi2.libgcc */

        default:
          return -1;
        }

    case CLZ:
      if (pattern101 (x1, 
26, 
E_QImode, 
E_HImode, 
24) != 0)
        return -1;
      return 1039; /* *clzhi2.libgcc_split */

    case CTZ:
      if (pattern101 (x1, 
26, 
E_QImode, 
E_HImode, 
24) != 0)
        return -1;
      return 1043; /* *ctzhi2.libgcc_split */

    case FFS:
      if (pattern101 (x1, 
26, 
E_QImode, 
E_HImode, 
24) != 0)
        return -1;
      return 1047; /* *ffshi2.libgcc_split */

    case BSWAP:
      if (pattern101 (x1, 
36, 
E_CCmode, 
E_SImode, 
22) != 0
          || !
#line 9605 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1053; /* *bswapsi2.libgcc */

    case ZERO_EXTRACT:
      return recog_69 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      return recog_67 (x1, insn, pnum_clobbers);

    case FRACT_CONVERT:
      return recog_55 (x1, insn, pnum_clobbers);

    case UNSIGNED_FRACT_CONVERT:
      return recog_54 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern100 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      switch (pattern236 (x3))
        {
        case 0:
          if (
#line 137 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3026; /* *ssaddqq3 */
          break;

        case 1:
          if (
#line 137 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3028; /* *ssaddhq3 */
          break;

        case 2:
          if (
#line 137 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3030; /* *ssaddha3 */
          break;

        case 3:
          if (
#line 137 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3032; /* *ssaddsa3 */
          break;

        case 4:
          if (
#line 137 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3034; /* *ssaddsq3 */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern237 (x2))
        {
        case 0:
          if (!
#line 301 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3230; /* *ssadddq3_insn */

        case 1:
          if (!
#line 301 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3232; /* *ssaddda3_insn */

        case 2:
          if (!
#line 301 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3234; /* *ssaddta3_insn */

        case 3:
          if (!
#line 322 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3242; /* *ssadddq3_const_insn */

        case 4:
          if (!
#line 322 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3244; /* *ssaddda3_const_insn */

        case 5:
          if (!
#line 322 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3246; /* *ssaddta3_const_insn */

        default:
          return -1;
        }

    case SS_MINUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern100 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      switch (pattern236 (x3))
        {
        case 0:
          if (
#line 137 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3027; /* *sssubqq3 */
          break;

        case 1:
          if (
#line 137 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3029; /* *sssubhq3 */
          break;

        case 2:
          if (
#line 137 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3031; /* *sssubha3 */
          break;

        case 3:
          if (
#line 137 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3033; /* *sssubsa3 */
          break;

        case 4:
          if (
#line 137 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3035; /* *sssubsq3 */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern237 (x2))
        {
        case 0:
          if (!
#line 301 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3231; /* *sssubdq3_insn */

        case 1:
          if (!
#line 301 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3233; /* *sssubda3_insn */

        case 2:
          if (!
#line 301 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3235; /* *sssubta3_insn */

        case 3:
          if (!
#line 322 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3243; /* *sssubdq3_const_insn */

        case 4:
          if (!
#line 322 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3245; /* *sssubda3_const_insn */

        case 5:
          if (!
#line 322 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3247; /* *sssubta3_const_insn */

        default:
          return -1;
        }

    case US_PLUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern100 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      switch (pattern238 (x3))
        {
        case 0:
          if (
#line 162 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3046; /* *usadduqq3 */
          break;

        case 1:
          if (
#line 162 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3048; /* *usadduhq3 */
          break;

        case 2:
          if (
#line 162 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3050; /* *usadduha3 */
          break;

        case 3:
          if (
#line 162 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3052; /* *usaddusa3 */
          break;

        case 4:
          if (
#line 162 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3054; /* *usaddusq3 */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern239 (x2))
        {
        case 0:
          if (!
#line 374 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3254; /* *usaddudq3_insn */

        case 1:
          if (!
#line 374 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3256; /* *usadduda3_insn */

        case 2:
          if (!
#line 374 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3258; /* *usadduta3_insn */

        case 3:
          if (!
#line 395 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3266; /* *usaddudq3_const_insn */

        case 4:
          if (!
#line 395 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3268; /* *usadduda3_const_insn */

        case 5:
          if (!
#line 395 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3270; /* *usadduta3_const_insn */

        default:
          return -1;
        }

    case US_MINUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern100 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      switch (pattern238 (x3))
        {
        case 0:
          if (
#line 162 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3047; /* *ussubuqq3 */
          break;

        case 1:
          if (
#line 162 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3049; /* *ussubuhq3 */
          break;

        case 2:
          if (
#line 162 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3051; /* *ussubuha3 */
          break;

        case 3:
          if (
#line 162 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3053; /* *ussubusa3 */
          break;

        case 4:
          if (
#line 162 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3055; /* *ussubusq3 */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern239 (x2))
        {
        case 0:
          if (!
#line 374 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3255; /* *ussubudq3_insn */

        case 1:
          if (!
#line 374 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3257; /* *ussubuda3_insn */

        case 2:
          if (!
#line 374 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3259; /* *ussubuta3_insn */

        case 3:
          if (!
#line 395 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3267; /* *ussubudq3_const_insn */

        case 4:
          if (!
#line 395 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3269; /* *ussubuda3_const_insn */

        case 5:
          if (!
#line 395 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3271; /* *ussubuta3_const_insn */

        default:
          return -1;
        }

    case SS_NEG:
      if (GET_MODE (x3) == E_QQmode
          && pattern147 (x1) == 0
          && 
#line 200 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
        return 3057; /* *ssnegqq2 */
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern148 (x1))
        {
        case 0:
          if (!
#line 252 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3065; /* *ssneghq2 */

        case 1:
          if (!
#line 252 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3067; /* *ssnegha2 */

        case 2:
          if (!
#line 272 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3073; /* *ssnegsa2 */

        case 3:
          if (!
#line 272 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3075; /* *ssnegsq2 */

        default:
          return -1;
        }

    case SS_ABS:
      if (GET_MODE (x3) == E_QQmode
          && pattern147 (x1) == 0
          && 
#line 218 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
        return 3059; /* *ssabsqq2 */
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern148 (x1))
        {
        case 0:
          if (!
#line 252 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3064; /* *ssabshq2 */

        case 1:
          if (!
#line 252 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3066; /* *ssabsha2 */

        case 2:
          if (!
#line 272 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3072; /* *ssabssa2 */

        case 3:
          if (!
#line 272 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3074; /* *ssabssq2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      if (!register_operand (x3, E_QImode)
          || GET_MODE (x2) != E_QImode)
        return NULL;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[2] = x4;
          if (!register_operand (operands[2], E_QImode))
            return NULL;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_QImode))
            return NULL;
          operands[1] = x3;
          if (!
#line 4756 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_375 (insn, operands);

        case CONST_INT:
          if (XWINT (x4, 0) != 1L)
            return NULL;
          x5 = XEXP (x1, 0);
          if (GET_CODE (x5) != ZERO_EXTRACT
              || GET_MODE (x5) != E_QImode)
            return NULL;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], E_QImode))
            return NULL;
          x8 = XEXP (x5, 2);
          operands[1] = x8;
          if (!const_0_to_7_operand (operands[1], E_QImode))
            return NULL;
          operands[2] = x3;
          if (!
#line 10086 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_662 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern81 (x2))
        {
        case 0:
          if (!(
#line 10152 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10154 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_667 (insn, operands);

        case 1:
          if (!(
#line 10152 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10154 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_671 (insn, operands);

        case 2:
          if (!(
#line 10152 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10154 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_675 (insn, operands);

        case 3:
          if (!
#line 10992 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1018 (insn, operands);

        case 4:
          if (!(
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10201 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_691 (insn, operands);

        case 5:
          if (!(
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10201 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_695 (insn, operands);

        case 6:
          if (!(
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10201 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_703 (insn, operands);

        case 7:
          if (!(
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_699 (insn, operands);

        case 8:
          if (!(
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_707 (insn, operands);

        case 9:
          if (!(
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_711 (insn, operands);

        case 10:
          if (!
#line 11043 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1024 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern48 (x1))
        {
        case 0:
          if (!(
#line 10152 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10154 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_669 (insn, operands);

        case 1:
          if (!(
#line 10152 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10154 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_673 (insn, operands);

        case 2:
          if (!(
#line 10152 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10154 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_677 (insn, operands);

        case 3:
          if (!(
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10201 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_693 (insn, operands);

        case 4:
          if (!(
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10201 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_697 (insn, operands);

        case 5:
          if (!(
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10201 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_705 (insn, operands);

        case 6:
          if (!(
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_701 (insn, operands);

        case 7:
          if (!(
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_709 (insn, operands);

        case 8:
          if (!(
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_713 (insn, operands);

        case 9:
          if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_915 (insn, operands);

        case 10:
          if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_921 (insn, operands);

        case 11:
          if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_933 (insn, operands);

        case 12:
          if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_927 (insn, operands);

        case 13:
          if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_939 (insn, operands);

        case 14:
          if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_945 (insn, operands);

        case 15:
          if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_914 (insn, operands);

        case 16:
          if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_920 (insn, operands);

        case 17:
          if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_932 (insn, operands);

        case 18:
          if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_926 (insn, operands);

        case 19:
          if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_938 (insn, operands);

        case 20:
          if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_944 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      switch (pattern3 (x2))
        {
        case 0:
          if (!(
#line 10175 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(2 > 1) && 
#line 10177 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_679 (insn, operands);

        case 1:
          if (!(
#line 10175 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 1) && 
#line 10177 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_681 (insn, operands);

        case 2:
          if (!(
#line 10175 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 2) && 
#line 10177 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_685 (insn, operands);

        case 3:
          if (!(
#line 10175 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 1) && 
#line 10177 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_683 (insn, operands);

        case 4:
          if (!(
#line 10175 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 2) && 
#line 10177 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_687 (insn, operands);

        case 5:
          if (!(
#line 10175 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 3) && 
#line 10177 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_689 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x9 = XEXP (x3, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTRACT:
          switch (pattern11 (x2))
            {
            case 0:
              if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_816 (insn, operands);

            case 1:
              if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_828 (insn, operands);

            case 2:
              if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_840 (insn, operands);

            case 3:
              if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_852 (insn, operands);

            case 4:
              if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_819 (insn, operands);

            case 5:
              if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_831 (insn, operands);

            case 6:
              if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_843 (insn, operands);

            case 7:
              if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_855 (insn, operands);

            case 8:
              if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_822 (insn, operands);

            case 9:
              if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_834 (insn, operands);

            case 10:
              if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_846 (insn, operands);

            case 11:
              if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_858 (insn, operands);

            case 12:
              if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_825 (insn, operands);

            case 13:
              if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_837 (insn, operands);

            case 14:
              if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_849 (insn, operands);

            case 15:
              if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_861 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern12 (x2))
            {
            case 0:
              if (!(
#line 10813 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_948 (insn, operands);

            case 1:
              if (!(
#line 10813 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_951 (insn, operands);

            case 2:
              if (!(
#line 10813 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_954 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern87 (x2))
        {
        case 0:
          if (!(
#line 10757 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_864 (insn, operands);

        case 1:
          if (!(
#line 10757 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_867 (insn, operands);

        case 2:
          if (!(
#line 10757 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_870 (insn, operands);

        case 3:
          if (!(
#line 10757 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_873 (insn, operands);

        case 4:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_878 (insn, operands);

        case 5:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_884 (insn, operands);

        case 6:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_896 (insn, operands);

        case 7:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_890 (insn, operands);

        case 8:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_902 (insn, operands);

        case 9:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_908 (insn, operands);

        case 10:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_879 (insn, operands);

        case 11:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_885 (insn, operands);

        case 12:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_897 (insn, operands);

        case 13:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_891 (insn, operands);

        case 14:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_903 (insn, operands);

        case 15:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_909 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      switch (pattern42 (x1))
        {
        case 0:
          if (!
#line 10948 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1015 (insn, operands);

        case 1:
          if (!
#line 11018 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1021 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      if (pattern44 (x1) != 0
          || !
#line 11067 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
        return NULL;
      return gen_split_1027 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT)
    {
      x5 = XEXP (x3, 0);
      if (rtx_equal_p (x5, operands[0]))
        {
          switch (XWINT (x4, 0))
            {
            case 4L:
              switch (pattern178 (x3))
                {
                case 0:
                  return gen_split_517 (insn, operands);

                case 1:
                  return gen_split_518 (insn, operands);

                case 2:
                  return gen_split_519 (insn, operands);

                default:
                  break;
                }
              break;

            case 5L:
              switch (pattern178 (x3))
                {
                case 0:
                  return gen_split_520 (insn, operands);

                case 1:
                  return gen_split_521 (insn, operands);

                case 2:
                  return gen_split_522 (insn, operands);

                default:
                  break;
                }
              break;

            case 6L:
              if (d_register_operand (operands[0], E_QImode)
                  && GET_MODE (x3) == E_QImode)
                return gen_split_523 (insn, operands);
              break;

            default:
              break;
            }
        }
    }
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  operands[2] = x4;
  switch (pattern153 (x3))
    {
    case 0:
      if (
#line 5976 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_524 (insn, operands);
      break;

    case 1:
      if (
#line 5976 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_525 (insn, operands);
      break;

    case 2:
      if (
#line 5976 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_526 (insn, operands);
      break;

    case 3:
      if (
#line 6002 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_527 (insn, operands);
      break;

    case 4:
      if (
#line 6002 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_528 (insn, operands);
      break;

    case 5:
      if (
#line 6002 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_529 (insn, operands);
      break;

    case 6:
      if (
#line 6002 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_530 (insn, operands);
      break;

    case 7:
      if (
#line 6002 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_531 (insn, operands);
      break;

    case 8:
      if (
#line 6061 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_533 (insn, operands);
      break;

    case 9:
      if (
#line 6061 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_534 (insn, operands);
      break;

    case 10:
      if (
#line 6061 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_535 (insn, operands);
      break;

    case 11:
      if (
#line 6061 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_536 (insn, operands);
      break;

    case 12:
      if (
#line 6061 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_537 (insn, operands);
      break;

    default:
      break;
    }
  if (reg_or_low_io_operand (operands[1], E_QImode)
      && x4 == const_int_rtx[MAX_SAVED_CONST_INT + 7]
      && register_operand (operands[0], E_QImode)
      && GET_MODE (x3) == E_QImode
      && (
#line 10560 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10562 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
    return gen_split_751 (insn, operands);
  if (GET_CODE (x5) != REG)
    return NULL;
  switch (pattern56 (x1))
    {
    case 0:
      if (!(
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1937 (insn, operands);

    case 1:
      if (!(
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1941 (insn, operands);

    case 2:
      if (!(
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1945 (insn, operands);

    case 3:
      if (!(
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1949 (insn, operands);

    case 4:
      if (!(
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1953 (insn, operands);

    case 5:
      if (!(
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1957 (insn, operands);

    case 6:
      if (!(
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1961 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_26 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (!scratch_operand (x5, E_QImode))
    return NULL;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 1);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x7;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern308 (x6, 
E_HImode) != 0
              || !
#line 2135 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_152 (insn, operands);

        case E_HQmode:
          if (pattern308 (x6, 
E_HQmode) != 0
              || !
#line 2135 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_153 (insn, operands);

        case E_UHQmode:
          if (pattern308 (x6, 
E_UHQmode) != 0
              || !
#line 2135 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_154 (insn, operands);

        case E_HAmode:
          if (pattern308 (x6, 
E_HAmode) != 0
              || !
#line 2135 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_155 (insn, operands);

        case E_UHAmode:
          if (pattern308 (x6, 
E_UHAmode) != 0
              || !
#line 2135 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_156 (insn, operands);

        case E_SImode:
          if (pattern308 (x6, 
E_SImode) != 0
              || !
#line 2165 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_157 (insn, operands);

        case E_SQmode:
          if (pattern308 (x6, 
E_SQmode) != 0
              || !
#line 2165 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_158 (insn, operands);

        case E_USQmode:
          if (pattern308 (x6, 
E_USQmode) != 0
              || !
#line 2165 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_159 (insn, operands);

        case E_SAmode:
          if (pattern308 (x6, 
E_SAmode) != 0
              || !
#line 2165 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_160 (insn, operands);

        case E_USAmode:
          if (pattern308 (x6, 
E_USAmode) != 0
              || !
#line 2165 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_161 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      operands[4] = x5;
      switch (pattern234 (x6))
        {
        case 0:
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 2662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2664 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_280 (insn, operands);

        case 1:
          if (s8_operand (operands[2], E_HImode)
              && (
#line 2877 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2879 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_292 (insn, operands);
          if (!u8_operand (operands[2], E_HImode)
              || !(
#line 2968 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)) && 
#line 2971 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_297 (insn, operands);

        case 2:
          if (!u8_operand (operands[2], E_HImode)
              || !(
#line 2877 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2879 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_293 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      if (pattern222 (x6) != 0)
        return NULL;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      operands[4] = x5;
      x10 = XEXP (x7, 0);
      switch (pattern352 (x10))
        {
        case 0:
          if (!(
#line 2900 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2902 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_294 (insn, operands);

        case 1:
          if (!(
#line 2924 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2926 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_295 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return NULL;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!l_register_operand (operands[0], E_QImode)
          || !const_operand (operands[1], E_QImode)
          || !
#line 892 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!satisfies_constraint_Y00 (operands[1])
   && !satisfies_constraint_Y01 (operands[1])
   && !satisfies_constraint_Ym1 (operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_1 (insn, operands);

    case E_QQmode:
      if (!l_register_operand (operands[0], E_QQmode)
          || !const_operand (operands[1], E_QQmode)
          || !
#line 892 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!satisfies_constraint_Y00 (operands[1])
   && !satisfies_constraint_Y01 (operands[1])
   && !satisfies_constraint_Ym1 (operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_2 (insn, operands);

    case E_UQQmode:
      if (!l_register_operand (operands[0], E_UQQmode)
          || !const_operand (operands[1], E_UQQmode)
          || !
#line 892 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!satisfies_constraint_Y00 (operands[1])
   && !satisfies_constraint_Y01 (operands[1])
   && !satisfies_constraint_Ym1 (operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_3 (insn, operands);

    case E_HImode:
      if (l_register_operand (operands[0], E_HImode)
          && const_or_immediate_operand (operands[1], E_HImode)
          && 
#line 931 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (HImode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_4 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2
          || !d_register_operand (operands[0], E_HImode))
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != PARALLEL)
        return NULL;
      if (const_int_operand (operands[1], E_HImode))
        {
          switch (XVECLEN (x6, 0))
            {
            case 3:
              switch (pattern312 (x6, 
E_HImode))
                {
                case 0:
                  if (
#line 1036 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_15 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if (
#line 1036 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_16 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if (
#line 1036 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_17 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
              break;

            case 2:
              if (pattern315 (x6, 
E_HImode, 
PLUS) == 0)
                {
                  x7 = XVECEXP (x6, 0, 0);
                  x8 = XEXP (x7, 1);
                  x9 = XEXP (x8, 1);
                  operands[2] = x9;
                  if (register_operand (operands[2], E_HImode))
                    {
                      x10 = XEXP (x8, 0);
                      if (rtx_equal_p (x10, operands[0]))
                        {
                          x11 = XEXP (x7, 0);
                          if (rtx_equal_p (x11, operands[0])
                              && 
#line 1055 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                            {
                              *pmatch_len_ = 1;
                              res = gen_peephole2_24 (insn, operands);
                              if (res != NULL_RTX)
                                return res;
                            }
                        }
                    }
                }
              break;

            default:
              break;
            }
        }
      if (XVECLEN (x6, 0) != 2
          || !const_operand (operands[1], E_HImode)
          || pattern310 (x6, 
E_HImode) != 0
          || !
#line 1868 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_32 (insn, operands);

    case E_HQmode:
      if (l_register_operand (operands[0], E_HQmode)
          && const_or_immediate_operand (operands[1], E_HQmode)
          && 
#line 931 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (HQmode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_5 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern311 (x6, 
E_HQmode) != 0
          || !
#line 1868 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_33 (insn, operands);

    case E_UHQmode:
      if (l_register_operand (operands[0], E_UHQmode)
          && const_or_immediate_operand (operands[1], E_UHQmode)
          && 
#line 931 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (UHQmode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_6 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern311 (x6, 
E_UHQmode) != 0
          || !
#line 1868 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_34 (insn, operands);

    case E_HAmode:
      if (l_register_operand (operands[0], E_HAmode)
          && const_or_immediate_operand (operands[1], E_HAmode)
          && 
#line 931 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (HAmode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_7 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern311 (x6, 
E_HAmode) != 0
          || !
#line 1868 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_35 (insn, operands);

    case E_UHAmode:
      if (l_register_operand (operands[0], E_UHAmode)
          && const_or_immediate_operand (operands[1], E_UHAmode)
          && 
#line 931 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (UHAmode)))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_8 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern311 (x6, 
E_UHAmode) != 0
          || !
#line 1868 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_36 (insn, operands);

    case E_PSImode:
      if (peep2_current_count >= 2)
        {
          x6 = PATTERN (peep2_next_insn (1));
          switch (pattern313 (x6, 
E_PSImode))
            {
            case 0:
              if (
#line 1036 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_18 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 1036 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_19 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 1036 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_20 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (!l_register_operand (operands[0], E_PSImode)
          || !immediate_operand (operands[1], E_PSImode)
          || !
#line 1108 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(operands[1] != const0_rtx
   && operands[1] != constm1_rtx))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_25 (insn, operands);

    case E_SImode:
      if (peep2_current_count >= 2)
        {
          x6 = PATTERN (peep2_next_insn (1));
          switch (pattern313 (x6, 
E_SImode))
            {
            case 0:
              if (
#line 1036 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_21 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 1036 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_22 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 1036 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reg_overlap_mentioned_p (operands[0], operands[2])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_23 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (!l_register_operand (operands[0], E_SImode)
          || !immediate_operand (operands[1], E_SImode)
          || !
#line 1163 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (SImode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_26 (insn, operands);

    case E_SQmode:
      if (!l_register_operand (operands[0], E_SQmode)
          || !immediate_operand (operands[1], E_SQmode)
          || !
#line 1163 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (SQmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_27 (insn, operands);

    case E_USQmode:
      if (!l_register_operand (operands[0], E_USQmode)
          || !immediate_operand (operands[1], E_USQmode)
          || !
#line 1163 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (USQmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_28 (insn, operands);

    case E_SAmode:
      if (!l_register_operand (operands[0], E_SAmode)
          || !immediate_operand (operands[1], E_SAmode)
          || !
#line 1163 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (SAmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_29 (insn, operands);

    case E_USAmode:
      if (!l_register_operand (operands[0], E_USAmode)
          || !immediate_operand (operands[1], E_USAmode)
          || !
#line 1163 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (USAmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_30 (insn, operands);

    case E_SFmode:
      if (!l_register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !
#line 1267 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(operands[1] != CONST0_RTX (SFmode)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_31 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return NULL;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x7) != PARALLEL)
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (pattern326 (x7) != 0)
        return NULL;
      x8 = XVECEXP (x7, 0, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (odd_register_operand (operands[2], E_QImode)
          && even_register_operand (operands[0], E_QImode)
          && even_register_operand (operands[1], E_QImode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (odd_register_operand (operands[3], E_QImode)
              && 
#line 987 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[0]) == REGNO (operands[2]) - 1
   && REGNO (operands[1]) == REGNO (operands[3]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_9 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (even_register_operand (operands[2], E_QImode)
          && odd_register_operand (operands[0], E_QImode)
          && odd_register_operand (operands[1], E_QImode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (even_register_operand (operands[3], E_QImode)
              && 
#line 1005 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[2]) == REGNO (operands[0]) - 1
   && REGNO (operands[3]) == REGNO (operands[1]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_12 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3)
        return NULL;
      switch (pattern376 (x8, 
E_QImode))
        {
        case 0:
          if (!
#line 4986 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_76 (insn, operands);

        case 1:
          if (!
#line 4986 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_77 (insn, operands);

        case 2:
          if (!
#line 4986 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_78 (insn, operands);

        default:
          return NULL;
        }

    case E_QQmode:
      if (pattern326 (x7) != 0)
        return NULL;
      x8 = XVECEXP (x7, 0, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (odd_register_operand (operands[2], E_QQmode)
          && even_register_operand (operands[0], E_QQmode)
          && even_register_operand (operands[1], E_QQmode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (odd_register_operand (operands[3], E_QQmode)
              && 
#line 987 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[0]) == REGNO (operands[2]) - 1
   && REGNO (operands[1]) == REGNO (operands[3]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_10 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (even_register_operand (operands[2], E_QQmode)
          && odd_register_operand (operands[0], E_QQmode)
          && odd_register_operand (operands[1], E_QQmode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (even_register_operand (operands[3], E_QQmode)
              && 
#line 1005 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[2]) == REGNO (operands[0]) - 1
   && REGNO (operands[3]) == REGNO (operands[1]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_13 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3)
        return NULL;
      switch (pattern376 (x8, 
E_QQmode))
        {
        case 0:
          if (!
#line 4986 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_79 (insn, operands);

        case 1:
          if (!
#line 4986 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_80 (insn, operands);

        case 2:
          if (!
#line 4986 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_81 (insn, operands);

        default:
          return NULL;
        }

    case E_UQQmode:
      if (pattern326 (x7) != 0)
        return NULL;
      x8 = XVECEXP (x7, 0, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (odd_register_operand (operands[2], E_UQQmode)
          && even_register_operand (operands[0], E_UQQmode)
          && even_register_operand (operands[1], E_UQQmode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (odd_register_operand (operands[3], E_UQQmode)
              && 
#line 987 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[0]) == REGNO (operands[2]) - 1
   && REGNO (operands[1]) == REGNO (operands[3]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_11 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (even_register_operand (operands[2], E_UQQmode)
          && odd_register_operand (operands[0], E_UQQmode)
          && odd_register_operand (operands[1], E_UQQmode))
        {
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (even_register_operand (operands[3], E_UQQmode)
              && 
#line 1005 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && REGNO (operands[2]) == REGNO (operands[0]) - 1
   && REGNO (operands[3]) == REGNO (operands[1]) - 1))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_14 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (peep2_current_count < 3)
        return NULL;
      switch (pattern376 (x8, 
E_UQQmode))
        {
        case 0:
          if (!
#line 4986 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_82 (insn, operands);

        case 1:
          if (!
#line 4986 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_83 (insn, operands);

        case 2:
          if (!
#line 4986 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (3, operands[0])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_84 (insn, operands);

        default:
          return NULL;
        }

    case E_HImode:
      switch (pattern327 (x7, 
E_HImode))
        {
        case 0:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_43 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_44 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_45 (insn, operands);

        default:
          return NULL;
        }

    case E_SImode:
      switch (pattern327 (x7, 
E_SImode))
        {
        case 0:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_46 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_47 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_48 (insn, operands);

        default:
          return NULL;
        }

    case E_PSImode:
      switch (pattern327 (x7, 
E_PSImode))
        {
        case 0:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_49 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_50 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_51 (insn, operands);

        default:
          return NULL;
        }

    case E_HQmode:
      switch (pattern327 (x7, 
E_HQmode))
        {
        case 0:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_52 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_53 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_54 (insn, operands);

        default:
          return NULL;
        }

    case E_UHQmode:
      switch (pattern327 (x7, 
E_UHQmode))
        {
        case 0:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_55 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_56 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_57 (insn, operands);

        default:
          return NULL;
        }

    case E_HAmode:
      switch (pattern327 (x7, 
E_HAmode))
        {
        case 0:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_58 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_59 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_60 (insn, operands);

        default:
          return NULL;
        }

    case E_UHAmode:
      switch (pattern327 (x7, 
E_UHAmode))
        {
        case 0:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_61 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_62 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_63 (insn, operands);

        default:
          return NULL;
        }

    case E_SQmode:
      switch (pattern327 (x7, 
E_SQmode))
        {
        case 0:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_64 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_65 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_66 (insn, operands);

        default:
          return NULL;
        }

    case E_USQmode:
      switch (pattern327 (x7, 
E_USQmode))
        {
        case 0:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_67 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_68 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_69 (insn, operands);

        default:
          return NULL;
        }

    case E_SAmode:
      switch (pattern327 (x7, 
E_SAmode))
        {
        case 0:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_70 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_71 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_72 (insn, operands);

        default:
          return NULL;
        }

    case E_USAmode:
      switch (pattern327 (x7, 
E_USAmode))
        {
        case 0:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_73 (insn, operands);

        case 1:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_74 (insn, operands);

        case 2:
          if (!
#line 4953 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_75 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
