/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_PSImode
          || !register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[1], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern25 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i1)
    return -1;
  switch (GET_MODE (x2))
    {
    case E_SAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_SAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_SAmode)
        return -1;
      return 0;

    case E_USAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_USAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_USAmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  return pattern37 (x1); /* [-1, 5] */
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  return pattern41 (x2); /* [-1, 1] */
}

int
pattern45 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x3, 2);
  operands[2] = x7;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i1
      || GET_MODE (x4) != i2)
    return -1;
  return 0;
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (REGNO (x4))
    {
    case 24:
      if (REGNO (x2) != 24)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_HQmode:
          if (GET_MODE (x3) != E_HQmode
              || GET_MODE (x4) != E_HQmode)
            return -1;
          return 0;

        case E_HAmode:
          if (GET_MODE (x3) != E_HAmode
              || GET_MODE (x4) != E_HAmode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 22:
      if (REGNO (x2) != 22)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SAmode:
          if (GET_MODE (x3) != E_SAmode
              || GET_MODE (x4) != E_SAmode)
            return -1;
          return 2;

        case E_SQmode:
          if (GET_MODE (x3) != E_SQmode
              || GET_MODE (x4) != E_SQmode)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != AND
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      switch (GET_CODE (operands[3]))
        {
        case CONST_INT:
          return pattern76 (x1); /* [-1, 3] */

        case REG:
        case SUBREG:
          if (!register_operand (operands[3], E_QImode)
              || !register_operand (operands[0], E_QImode)
              || GET_MODE (x1) != E_QImode
              || GET_MODE (x2) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case XOR:
      if (GET_MODE (x5) != E_QImode
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || GET_MODE (x2) != E_QImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      if (!const_int_operand (operands[4], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      return 0;

    case SIGN_EXTEND:
      return 1;

    case ZERO_EXTEND:
      return 2;

    default:
      return -1;
    }
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode
      || GET_MODE (x2) != E_QImode)
    return -1;
  x4 = XEXP (x2, 2);
  operands[3] = x4;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  x5 = XEXP (x1, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_QImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x8 = XEXP (x5, 2);
      operands[1] = x8;
      if (!const_0_to_7_operand (operands[1], E_QImode))
        return -1;
      x9 = XEXP (x3, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[4] = x10;
      if (!const_int_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[0] = x5;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      if (!reg_or_low_io_operand (operands[1], E_QImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      if (!single_one_operand (operands[2], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern109 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern108 (x1, 
E_HImode); /* [-1, 0] */

    case E_PSImode:
      if (pattern108 (x1, 
E_PSImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern108 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern118 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != REG)
    return -1;
  x11 = XEXP (x7, 0);
  if (GET_CODE (x11) != REG)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG)
    return -1;
  x14 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG)
    return -1;
  x16 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG)
    return -1;
  switch (REGNO (x4))
    {
    case 24:
      return 0;

    case 22:
      return 1;

    default:
      return -1;
    }
}

int
pattern131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x1) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !register_operand (operands[2], E_QImode)
              || !const7_operand (operands[3], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !register_operand (operands[2], E_HImode)
              || !const15_operand (operands[3], E_QImode))
            return -1;
          return 1;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x1) != E_PSImode
              || !register_operand (operands[1], E_PSImode)
              || GET_MODE (x3) != E_PSImode
              || !register_operand (operands[2], E_PSImode)
              || !const23_operand (operands[3], E_QImode))
            return -1;
          return 2;

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[2], E_SImode)
              || !const31_operand (operands[3], E_QImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[2], E_QImode)
              || !const15_operand (operands[3], E_QImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x1) != E_PSImode
              || !register_operand (operands[1], E_PSImode)
              || GET_MODE (x3) != E_PSImode
              || GET_MODE (x5) != E_PSImode
              || !const23_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_QImode:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              return 5;

            case E_HImode:
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x5) != E_SImode
              || !const31_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_QImode:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              return 7;

            case E_HImode:
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 8;

            case E_PSImode:
              if (!register_operand (operands[2], E_PSImode))
                return -1;
              return 9;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern164 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_7_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_QImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern169 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern172 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 21
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 30
      || GET_MODE (x9) != E_HImode)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_QImode)
          || GET_MODE (x5) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || !memory_operand (operands[1], E_QQmode)
          || GET_MODE (x5) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || !memory_operand (operands[1], E_UQQmode)
          || GET_MODE (x5) != E_UQQmode)
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !memory_operand (operands[1], E_HImode)
          || GET_MODE (x5) != E_HImode)
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || !memory_operand (operands[1], E_HQmode)
          || GET_MODE (x5) != E_HQmode)
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || !memory_operand (operands[1], E_UHQmode)
          || GET_MODE (x5) != E_UHQmode)
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || !memory_operand (operands[1], E_HAmode)
          || GET_MODE (x5) != E_HAmode)
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || !memory_operand (operands[1], E_UHAmode)
          || GET_MODE (x5) != E_UHAmode)
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_SImode)
          || GET_MODE (x5) != E_SImode)
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !memory_operand (operands[1], E_SQmode)
          || GET_MODE (x5) != E_SQmode)
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !memory_operand (operands[1], E_USQmode)
          || GET_MODE (x5) != E_USQmode)
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !memory_operand (operands[1], E_SAmode)
          || GET_MODE (x5) != E_SAmode)
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !memory_operand (operands[1], E_USAmode)
          || GET_MODE (x5) != E_USAmode)
        return -1;
      return 12;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !memory_operand (operands[1], E_SFmode)
          || GET_MODE (x5) != E_SFmode)
        return -1;
      return 13;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !memory_operand (operands[1], E_PSImode)
          || GET_MODE (x5) != E_PSImode)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern205 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != IF_THEN_ELSE)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  return 0;
}

int
pattern217 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern224 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!const_2_to_7_operand (operands[2], E_HImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (x3))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      res = pattern4 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern241 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HQmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_HQmode)
        return -1;
      return 0;

    case E_UHQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_UHQmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_UHQmode)
        return -1;
      return 1;

    case E_HAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_HAmode)
        return -1;
      return 2;

    case E_UHAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_UHAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_UHAmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern248 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 6
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER
      || pattern247 (x1) != 0)
    return -1;
  return 0;
}

int
pattern253 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern185 (x5); /* [-1, 10] */
}

int
pattern256 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x1, 0);
  if (REGNO (x5) != i3
      || GET_MODE (x5) != i1
      || GET_MODE (x2) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern261 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (REGNO (x4) != 24
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 25
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || pattern260 (x1, 
24, 
E_HImode, 
22, 
E_HImode) != 0)
    return -1;
  return 0;
}

int
pattern268 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!pseudo_register_or_const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!pseudo_register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern273 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 30
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  return pattern272 (x4); /* [-1, 1] */
}

int
pattern279 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != 3
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 32
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 32
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != UNSPEC_VOLATILE
      || XVECLEN (x7, 0) != 1
      || XINT (x7, 1) != 6
      || GET_MODE (x7) != E_BLKmode
      || !const_int_operand (operands[0], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XVECEXP (x8, 0, 1);
  operands[1] = x9;
  if (!const_int_operand (operands[1], E_QImode))
    return -1;
  x10 = XEXP (x6, 0);
  operands[2] = x10;
  x11 = XVECEXP (x7, 0, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern291 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (REGNO (x4) != 24
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (REGNO (x5) != 25
      || pattern260 (x1, 
24, 
E_HImode, 
22, 
E_HImode) != 0)
    return -1;
  return 0;
}

int
pattern293 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 4:
      return pattern291 (x1); /* [-1, 0] */

    case 5:
      if (pattern291 (x1) != 0)
        return -1;
      return 1;

    case 6:
      if (pattern291 (x1) != 0)
        return -1;
      return 2;

    case 8:
      x4 = XVECEXP (x3, 0, 1);
      if (REGNO (x4) != 24)
        return -1;
      res = pattern292 (x1);
      if (res >= 0)
        return res + 3; /* [3, 12] */
      return -1;

    default:
      return -1;
    }
}

int
pattern297 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern302 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != i2
      || GET_MODE (x4) != i1
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern308 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_or_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern312 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  switch (GET_CODE (x7))
    {
    case PLUS:
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x7, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 0;

    case IOR:
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x7, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 1;

    case AND:
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], i1))
        return -1;
      x10 = XEXP (x7, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern329 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_DImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_DQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DQmode)
        return -1;
      return 1;

    case E_UDQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UDQmode)
        return -1;
      return 2;

    case E_DAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DAmode)
        return -1;
      return 3;

    case E_UDAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UDAmode)
        return -1;
      return 4;

    case E_TAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TAmode)
        return -1;
      return 5;

    case E_UTAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UTAmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern338 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (REGNO (x4))
    {
    case 22:
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 24
          || GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      if (REGNO (x7) != 21
          || GET_MODE (x7) != E_QImode
          || GET_MODE (x3) != E_HImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 0);
      if (GET_MODE (x10) != E_HImode)
        return -1;
      return 0;

    case 25:
      if (pattern337 (x1) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern348 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  if (!const0_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  return pattern347 (x3); /* [-1, 1] */
}

int
pattern352 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case ZERO_EXTEND:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_QImode)
          || !const_2_to_7_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case SIGN_EXTEND:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_QImode)
          || !const_1_to_6_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern357 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 18
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 26
      || GET_MODE (x5) != E_HImode)
    return -1;
  return 0;
}

int
pattern363 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UQQmode)
        return -1;
      return 2;

    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      return 3;

    case E_HQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      return 4;

    case E_UHQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      return 5;

    case E_HAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      return 6;

    case E_UHAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      return 7;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      return 8;

    case E_SQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SQmode)
        return -1;
      return 9;

    case E_USQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USQmode)
        return -1;
      return 10;

    case E_SAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SAmode)
        return -1;
      return 11;

    case E_USAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USAmode)
        return -1;
      return 12;

    case E_SFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      return 13;

    case E_PSImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern385 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[0] = x3;
  if (!const_int_operand (operands[0], E_QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 6);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern394 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[1], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case EQ:
      return pattern387 (x1); /* [-1, 0] */

    case NE:
      if (pattern387 (x1) != 0)
        return -1;
      return 1;

    case GE:
      if (pattern387 (x1) != 0)
        return -1;
      return 2;

    case LT:
      if (pattern387 (x1) != 0)
        return -1;
      return 3;

    case GT:
      if (pattern387 (x1) != 0)
        return -1;
      return 4;

    case LE:
      if (pattern387 (x1) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (pattern124 (x1, 
E_QImode) != 0)
        return -1;
      return 174; /* addqi3 */

    case E_QQmode:
      if (pattern124 (x1, 
E_QQmode) != 0)
        return -1;
      return 175; /* addqq3 */

    case E_UQQmode:
      if (pattern124 (x1, 
E_UQQmode) != 0)
        return -1;
      return 176; /* adduqq3 */

    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      operands[1] = x2;
      if (stack_register_operand (operands[1], E_HImode))
        {
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (stack_register_operand (operands[2], E_HImode))
            {
              x5 = XEXP (x3, 1);
              operands[0] = x5;
              if (avr_sp_immediate_operand (operands[0], E_HImode))
                return 193; /* *addhi3_sp */
            }
        }
      operands[0] = x2;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (nonmemory_or_const_operand (operands[2], E_HImode))
        return 194; /* *addhi3_split */
      if (pnum_clobbers == NULL
          || !const_operand (operands[2], E_HImode))
        return -1;
      *pnum_clobbers = 1;
      return 204; /* addhi3_clobber */

    case E_HQmode:
      operands[0] = x2;
      if (!register_operand (operands[0], E_HQmode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HQmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (nonmemory_or_const_operand (operands[2], E_HQmode))
        return 195; /* *addhq3_split */
      if (pnum_clobbers == NULL
          || !const_operand (operands[2], E_HQmode))
        return -1;
      *pnum_clobbers = 1;
      return 205; /* addhq3_clobber */

    case E_UHQmode:
      operands[0] = x2;
      if (!register_operand (operands[0], E_UHQmode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_UHQmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (nonmemory_or_const_operand (operands[2], E_UHQmode))
        return 196; /* *adduhq3_split */
      if (pnum_clobbers == NULL
          || !const_operand (operands[2], E_UHQmode))
        return -1;
      *pnum_clobbers = 1;
      return 206; /* adduhq3_clobber */

    case E_HAmode:
      operands[0] = x2;
      if (!register_operand (operands[0], E_HAmode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HAmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (nonmemory_or_const_operand (operands[2], E_HAmode))
        return 197; /* *addha3_split */
      if (pnum_clobbers == NULL
          || !const_operand (operands[2], E_HAmode))
        return -1;
      *pnum_clobbers = 1;
      return 207; /* addha3_clobber */

    case E_UHAmode:
      operands[0] = x2;
      if (!register_operand (operands[0], E_UHAmode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_UHAmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (nonmemory_or_const_operand (operands[2], E_UHAmode))
        return 198; /* *adduha3_split */
      if (pnum_clobbers == NULL
          || !const_operand (operands[2], E_UHAmode))
        return -1;
      *pnum_clobbers = 1;
      return 208; /* adduha3_clobber */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern124 (x1, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 214; /* addsi3 */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern124 (x1, 
E_SQmode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 215; /* addsq3 */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern124 (x1, 
E_USQmode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 216; /* addusq3 */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern124 (x1, 
E_SAmode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 217; /* addsa3 */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern124 (x1, 
E_USAmode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 218; /* addusa3 */

    case E_PSImode:
      if (pnum_clobbers == NULL
          || pattern124 (x1, 
E_PSImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 270; /* addpsi3 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  switch (pattern255 (x5, pnum_clobbers))
    {
    case 0:
      if (u8_operand (operands[2], E_HImode)
          && 
#line 2994 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        {
          *pnum_clobbers = 1;
          return 522; /* *muluqihi3.uconst */
        }
      if (!s8_operand (operands[2], E_HImode)
          || !
#line 3012 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      *pnum_clobbers = 1;
      return 523; /* *muluqihi3.sconst */

    case 1:
      if (
#line 3174 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 533; /* muluqihi3 */
      if (pnum_clobbers == NULL
          || !
#line 3187 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 534; /* *muluqihi3 */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      switch (pattern197 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 2465 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 478; /* mulqihi3_split */
          if (pnum_clobbers == NULL
              || !
#line 2478 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 480; /* mulqihi3 */

        case 1:
          if (!
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 548; /* *ssmulqiqisi3 */

        case 2:
          if (!
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 556; /* *ssmulqihisi3 */

        case 3:
          if (!
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 552; /* *ssmulhiqisi3 */

        case 4:
          if (!
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 560; /* *ssmulhihisi3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern197 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 2513 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 484; /* *sumulqihi3_split */
          if (pnum_clobbers == NULL
              || !
#line 2526 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 485; /* *sumulqihi3 */

        case 1:
          if (!
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 550; /* *sumulqiqisi3 */

        case 2:
          if (!
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 558; /* *sumulqihisi3 */

        case 3:
          if (!
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 554; /* *sumulhiqisi3 */

        case 4:
          if (!
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 562; /* *sumulhihisi3 */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      if (register_operand (operands[0], E_HImode))
        {
          res = recog_13 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!pseudo_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x5 = XEXP (x3, 0);
          if (GET_MODE (x5) != E_SImode
              || !pseudo_register_or_const_int_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!pseudo_register_operand (operands[1], E_QImode)
                  || !
#line 3535 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 545; /* *mulsqisi3 */

            case E_HImode:
              if (!pseudo_register_operand (operands[1], E_HImode)
                  || !
#line 3535 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 546; /* *mulshisi3 */

            default:
              return -1;
            }

        case E_PSImode:
          if (!pseudo_register_operand (operands[0], E_PSImode)
              || GET_MODE (x3) != E_PSImode)
            return -1;
          x5 = XEXP (x3, 0);
          if (GET_MODE (x5) != E_PSImode
              || !pseudo_register_operand (operands[1], E_QImode)
              || !pseudo_register_or_const_int_operand (operands[2], E_PSImode)
              || !
#line 4178 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 600; /* *mulsqipsi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (REGNO (x4))
    {
    case 22:
      if (pnum_clobbers == NULL
          || pattern165 (x1, 
E_SImode, 
22) != 0
          || !
#line 6311 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && optimize_size))
        return -1;
      *pnum_clobbers = 1;
      return 794; /* *negsi2.libgcc */

    case 18:
      if (pattern165 (x1, 
E_DImode, 
18) != 0)
        return -1;
      if (
#line 421 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3272; /* negdi2_insn */
      if (pnum_clobbers == NULL
          || !
#line 432 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3273; /* *negdi2_insn */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      switch (pattern75 (x1, pnum_clobbers))
        {
        case 0:
          return 626; /* iorqi3 */

        case 1:
          *pnum_clobbers = 1;
          return 628; /* iorhi3 */

        case 2:
          *pnum_clobbers = 1;
          return 630; /* iorpsi3 */

        case 3:
          *pnum_clobbers = 1;
          return 632; /* iorsi3 */

        default:
          return -1;
        }

    case MEM:
      if (pattern40 (x1) != 0
          || !single_one_operand (operands[1], E_QImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 981; /* *sbi */

    case AND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          operands[2] = x6;
          res = recog_17 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (XWINT (x6, 0) != 127L)
            return -1;
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != ASHIFT
              || GET_MODE (x7) != E_QImode)
            return -1;
          x8 = XEXP (x7, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || pattern217 (x2, 
E_QImode) != 0)
            return -1;
          return 1075; /* *movbitqi.7 */

        case SIGN_EXTRACT:
          switch (pattern11 (x2))
            {
            case 0:
              if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1273; /* *pixop-to-skip.qi */

            case 1:
              if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1285; /* *pixop-to-skip.qi */

            case 2:
              if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1297; /* *pixop-to-skip.qi */

            case 3:
              if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1309; /* *pixop-to-skip.qi */

            case 4:
              if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1276; /* *pixop-to-skip.hi */

            case 5:
              if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1288; /* *pixop-to-skip.hi */

            case 6:
              if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1300; /* *pixop-to-skip.hi */

            case 7:
              if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1312; /* *pixop-to-skip.hi */

            case 8:
              if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1279; /* *pixop-to-skip.psi */

            case 9:
              if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1291; /* *pixop-to-skip.psi */

            case 10:
              if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1303; /* *pixop-to-skip.psi */

            case 11:
              if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1315; /* *pixop-to-skip.psi */

            case 12:
              if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1282; /* *pixop-to-skip.si */

            case 13:
              if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1294; /* *pixop-to-skip.si */

            case 14:
              if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1306; /* *pixop-to-skip.si */

            case 15:
              if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1318; /* *pixop-to-skip.si */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern12 (x2))
            {
            case 0:
              if (!
#line 10813 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1405; /* *shl.and-to-skip.hi */

            case 1:
              if (!
#line 10813 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1408; /* *shl.and-to-skip.psi */

            case 2:
              if (!
#line 10813 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1411; /* *shl.and-to-skip.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern81 (x2))
        {
        case 0:
          if (!
#line 10152 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
            return -1;
          return 1093; /* *iorhi.lshiftrt */

        case 1:
          if (!
#line 10152 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
            return -1;
          return 1097; /* *iorpsi.lshiftrt */

        case 2:
          if (!
#line 10152 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
            return -1;
          return 1101; /* *iorsi.lshiftrt */

        case 3:
          if (!
#line 10988 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && avr_nonzero_bits_lsr_operands_p (IOR, operands)))
            return -1;
          return 1480; /* *nzb=1.ior.lsr_split */

        case 4:
          if (!
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
            return -1;
          return 1117; /* *iorhiqi.lshiftrt */

        case 5:
          if (!
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1121; /* *iorpsiqi.lshiftrt */

        case 6:
          if (!
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1129; /* *iorpsihi.lshiftrt */

        case 7:
          if (!
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1125; /* *iorsiqi.lshiftrt */

        case 8:
          if (!
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1133; /* *iorsihi.lshiftrt */

        case 9:
          if (!
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1137; /* *iorsipsi.lshiftrt */

        case 10:
          if (!
#line 11038 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && avr_nonzero_bits_lsr_operands_p (IOR, operands)))
            return -1;
          return 1486; /* *nzb=1.ior.lsr.not_split */

        default:
          return -1;
        }

    case ASHIFT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern83 (x2))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern79 (x2, 
E_HImode) == 0
                  && 
#line 10152 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
                return 1095; /* *iorhi.ashift */
              break;

            case E_PSImode:
              if (pattern79 (x2, 
E_PSImode) == 0
                  && 
#line 10152 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
                return 1099; /* *iorpsi.ashift */
              break;

            case E_SImode:
              if (pattern79 (x2, 
E_SImode) == 0
                  && 
#line 10152 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
                return 1103; /* *iorsi.ashift */
              break;

            case E_QImode:
              if (pattern80 (x2) == 0
                  && 
#line 11108 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && nonzero_bits (operands[1], QImode) == 1))
                return 1494; /* *nzb=1.ior.ashift_split */
              break;

            default:
              break;
            }
          x6 = XEXP (x3, 1);
          if (XWINT (x6, 0) != 8L
              || pattern218 (x2) != 0
              || !
#line 10264 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize))
            return -1;
          return 1144; /* *iorhi3.ashift8-reg.zerox */

        case 1:
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          switch (pattern46 (x2))
            {
            case 0:
              if (
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
                return 1119; /* *iorhiqi.ashift */
              break;

            case 1:
              if (
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
                return 1123; /* *iorpsiqi.ashift */
              break;

            case 2:
              if (
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
                return 1131; /* *iorpsihi.ashift */
              break;

            case 3:
              if (
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
                return 1127; /* *iorsiqi.ashift */
              break;

            case 4:
              if (
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
                return 1135; /* *iorsihi.ashift */
              break;

            case 5:
              if (
#line 10198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
                return 1139; /* *iorsipsi.ashift */
              break;

            default:
              break;
            }
          if (XWINT (x6, 0) != 8L)
            return -1;
          switch (pattern228 (x2))
            {
            case 0:
              if (!
#line 10215 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize))
                return -1;
              return 1141; /* *iorhi3.ashift8-ext.zerox */

            case 1:
              if (!
#line 10248 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize))
                return -1;
              return 1143; /* *iorhi3.ashift8-ext.reg */

            default:
              return -1;
            }

        case 2:
          if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1371; /* *shl.ext.and1-to-skip.hi */

        case 3:
          if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1377; /* *shl.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1389; /* *shl.ext.and1-to-skip.psi */

        case 5:
          if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1383; /* *shl.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1395; /* *shl.ext.and1-to-skip.si */

        case 7:
          if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1401; /* *shl.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10215 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize))
            return -1;
          return 1140; /* *iorhi3.ashift8-ext.zerox */

        case 9:
          if (!
#line 10248 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize))
            return -1;
          return 1142; /* *iorhi3.ashift8-ext.reg */

        case 10:
          if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1370; /* *shl.ext.and1-to-skip.hi */

        case 11:
          if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1376; /* *shl.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1388; /* *shl.ext.and1-to-skip.psi */

        case 13:
          if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1382; /* *shl.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1394; /* *shl.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1400; /* *shl.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern3 (x2))
        {
        case 0:
          return 1105; /* *iorhiqi.0 */

        case 1:
          return 1107; /* *iorpsiqi.0 */

        case 2:
          return 1111; /* *iorpsihi.0 */

        case 3:
          return 1109; /* *iorsiqi.0 */

        case 4:
          return 1113; /* *iorsihi.0 */

        case 5:
          return 1115; /* *iorsipsi.0 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern87 (x2))
        {
        case 0:
          if (!
#line 10757 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1321; /* *mul.and1-to-skip.qi */

        case 1:
          if (!
#line 10757 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1324; /* *mul.and1-to-skip.hi */

        case 2:
          if (!
#line 10757 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1327; /* *mul.and1-to-skip.psi */

        case 3:
          if (!
#line 10757 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1330; /* *mul.and1-to-skip.si */

        case 4:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1334; /* *mul.ext.and1-to-skip.hi */

        case 5:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1340; /* *mul.ext.and1-to-skip.psi */

        case 6:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1352; /* *mul.ext.and1-to-skip.psi */

        case 7:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1346; /* *mul.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1358; /* *mul.ext.and1-to-skip.si */

        case 9:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1364; /* *mul.ext.and1-to-skip.si */

        case 10:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1335; /* *mul.ext.and1-to-skip.hi */

        case 11:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1341; /* *mul.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1353; /* *mul.ext.and1-to-skip.psi */

        case 13:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1347; /* *mul.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1359; /* *mul.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1365; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      switch (pattern42 (x1))
        {
        case 0:
          if (!
#line 10943 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (IOR == IOR || IOR == XOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1474; /* *nzb=1.ior.zerox_split */

        case 1:
          if (!
#line 11012 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && (IOR == IOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1483; /* *nzb=1.ior.zerox.not_split */

        default:
          return -1;
        }

    case GE:
      if (pattern44 (x1) != 0
          || !
#line 11062 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (IOR == IOR || IOR == XOR
       || nonzero_bits (operands[2], QImode) == 1)))
        return -1;
      return 1489; /* *nzb=1.ior.ge0_split */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) == REG
          && REGNO (x7) == 36
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern108 (x4, 
E_QImode) == 0
                  && 
#line 1590 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return 177; /* *addqi3 */
              break;

            case E_QQmode:
              if (pattern108 (x4, 
E_QQmode) == 0
                  && 
#line 1590 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return 178; /* *addqq3 */
              break;

            case E_UQQmode:
              if (pattern108 (x4, 
E_UQQmode) == 0
                  && 
#line 1590 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return 179; /* *adduqq3 */
              break;

            case E_HImode:
              if (pattern308 (x4, 
E_HImode) == 0
                  && 
#line 1848 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return 199; /* *addhi3 */
              break;

            case E_HQmode:
              if (pattern308 (x4, 
E_HQmode) == 0
                  && 
#line 1848 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return 200; /* *addhq3 */
              break;

            case E_UHQmode:
              if (pattern308 (x4, 
E_UHQmode) == 0
                  && 
#line 1848 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return 201; /* *adduhq3 */
              break;

            case E_HAmode:
              if (pattern308 (x4, 
E_HAmode) == 0
                  && 
#line 1848 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return 202; /* *addha3 */
              break;

            case E_UHAmode:
              if (pattern308 (x4, 
E_UHAmode) == 0
                  && 
#line 1848 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return 203; /* *adduha3 */
              break;

            default:
              break;
            }
        }
      operands[3] = x7;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern307 (x4, 
E_HImode) != 0)
            return -1;
          return 204; /* addhi3_clobber */

        case E_HQmode:
          if (pattern307 (x4, 
E_HQmode) != 0)
            return -1;
          return 205; /* addhq3_clobber */

        case E_UHQmode:
          if (pattern307 (x4, 
E_UHQmode) != 0)
            return -1;
          return 206; /* adduhq3_clobber */

        case E_HAmode:
          if (pattern307 (x4, 
E_HAmode) != 0)
            return -1;
          return 207; /* addha3_clobber */

        case E_UHAmode:
          if (pattern307 (x4, 
E_UHAmode) != 0)
            return -1;
          return 208; /* adduha3_clobber */

        case E_SImode:
          if (pattern108 (x4, 
E_SImode) != 0)
            return -1;
          return 214; /* addsi3 */

        case E_SQmode:
          if (pattern108 (x4, 
E_SQmode) != 0)
            return -1;
          return 215; /* addsq3 */

        case E_USQmode:
          if (pattern108 (x4, 
E_USQmode) != 0)
            return -1;
          return 216; /* addusq3 */

        case E_SAmode:
          if (pattern108 (x4, 
E_SAmode) != 0)
            return -1;
          return 217; /* addsa3 */

        case E_USAmode:
          if (pattern108 (x4, 
E_USAmode) != 0)
            return -1;
          return 218; /* addusa3 */

        case E_PSImode:
          if (pattern108 (x4, 
E_PSImode) != 0)
            return -1;
          return 270; /* addpsi3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode
          || pattern262 (x1, 
E_HImode) != 0)
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 1672 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 183; /* *addhi3_zero_extend1 */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (nop_general_operand (operands[2], E_QImode))
    {
      switch (pattern235 (x1))
        {
        case 0:
          if (
#line 5987 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 746; /* *lshrqi3 */
          break;

        case 1:
          if (
#line 5987 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 747; /* *lshrqq3 */
          break;

        case 2:
          if (
#line 5987 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 748; /* *lshruqq3 */
          break;

        case 3:
          if (
#line 6015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 754; /* *lshrhi3 */
          break;

        case 4:
          if (
#line 6015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 755; /* *lshrhq3 */
          break;

        case 5:
          if (
#line 6015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 756; /* *lshruhq3 */
          break;

        case 6:
          if (
#line 6015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 757; /* *lshrha3 */
          break;

        case 7:
          if (
#line 6015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 758; /* *lshruha3 */
          break;

        case 8:
          if (
#line 6074 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 766; /* *lshrsi3 */
          break;

        case 9:
          if (
#line 6074 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 767; /* *lshrsq3 */
          break;

        case 10:
          if (
#line 6074 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 768; /* *lshrusq3 */
          break;

        case 11:
          if (
#line 6074 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 769; /* *lshrsa3 */
          break;

        case 12:
          if (
#line 6074 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 770; /* *lshrusa3 */
          break;

        default:
          break;
        }
    }
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_PSImode:
      if (pattern112 (x3) != 0)
        return -1;
      return 759; /* lshrpsi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SImode) != 0
          || !
#line 6165 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 776; /* *lshrsi3_const */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SQmode) != 0
          || !
#line 6165 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 777; /* *lshrsq3_const */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_USQmode) != 0
          || !
#line 6165 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 778; /* *lshrusq3_const */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_SAmode) != 0
          || !
#line 6165 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 779; /* *lshrsa3_const */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
E_USAmode) != 0
          || !
#line 6165 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 780; /* *lshrusa3_const */

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) == REG
          && REGNO (x6) == 36
          && GET_MODE (x6) == E_CCmode)
        {
          x7 = XEXP (x3, 0);
          operands[0] = x7;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern321 (x4, 
E_QImode) == 0
                  && 
#line 2218 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return 301; /* *mulqi3_enh */
              break;

            case E_HImode:
              if (pattern321 (x4, 
E_HImode) == 0
                  && 
#line 3286 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return 538; /* *mulhi3_enh */
              break;

            case E_QQmode:
              if (pattern321 (x4, 
E_QQmode) == 0
                  && 
#line 309 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return 3077; /* *mulqq3_enh */
              break;

            case E_UQQmode:
              if (pattern321 (x4, 
E_UQQmode) == 0
                  && 
#line 330 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return 3079; /* *muluqq3_enh */
              break;

            default:
              break;
            }
        }
      if (GET_CODE (x5) != REG)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != REG)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != REG
          || GET_CODE (x6) != REG)
        return -1;
      switch (REGNO (x5))
        {
        case 24:
          if (pattern281 (x1) != 0
              || !
#line 2239 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            return -1;
          return 302; /* *mulqi3_call_split */

        case 22:
          if (pattern282 (x1) != 0
              || !
#line 3715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 564; /* *mulsi3_call_split */

        case 18:
          switch (pattern283 (x1))
            {
            case 0:
              if (!
#line 425 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3082; /* *mulhq3.call_split */

            case 1:
              if (!
#line 425 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3083; /* *muluhq3.call_split */

            case 2:
              if (!
#line 425 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3084; /* *mulha3.call_split */

            case 3:
              if (!
#line 425 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3085; /* *muluha3.call_split */

            default:
              return -1;
            }

        case 16:
          if (REGNO (x8) != 20
              || REGNO (x7) != 24
              || REGNO (x6) != 36
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (pattern272 (x3))
            {
            case 0:
              if (!
#line 481 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 3092; /* *mulsa3.call */

            case 1:
              if (!
#line 481 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 3093; /* *mulusa3.call */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x5) == E_HImode)
        {
          res = recog_44 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != REG)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != REG)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode)
        return -1;
      switch (REGNO (x9))
        {
        case 18:
          if (pattern298 (x4, 
E_HImode, 
26, 
E_SImode) != 0
              || pattern299 (x3, 
E_SImode, 
22) != 0
              || !
#line 3788 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 570; /* *mulhisi3_call */

        case 26:
          if (pattern300 (x3, 
E_SImode, 
22, 
18, 
E_HImode) != 0
              || !
#line 3859 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 580; /* *mulshisi3_call */

        case 25:
          if (pattern300 (x3, 
E_PSImode, 
18, 
22, 
E_QImode) != 0
              || !
#line 4238 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 603; /* *mulsqipsi3.libgcc */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      res = recog_45 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != REG
          || pattern183 (x1, 
E_SImode, 
22) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      if (REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x9) != E_HImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_MODE (x8) != E_SImode)
        return -1;
      switch (REGNO (x9))
        {
        case 18:
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              x10 = XEXP (x8, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 26
                  || GET_MODE (x10) != E_HImode
                  || !
#line 3788 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 571; /* *umulhisi3_call */

            case SIGN_EXTEND:
              x10 = XEXP (x8, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 26
                  || GET_MODE (x10) != E_HImode
                  || !
#line 3838 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 577; /* *usmulhisi3_call */

            default:
              return -1;
            }

        case 26:
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 18
              || !
#line 3859 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 581; /* *muluhisi3_call */

        default:
          return -1;
        }

    case NOT:
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != ZERO_EXTEND)
        return -1;
      x11 = XEXP (x9, 0);
      if (GET_CODE (x11) != NOT)
        return -1;
      if (GET_MODE (x11) == E_QImode)
        {
          res = recog_46 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_MODE (x11) != E_HImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 26
          || GET_MODE (x12) != E_HImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 18
          || GET_MODE (x8) != E_SImode
          || pattern155 (x1, 
36, 
E_CCmode, 
E_SImode, 
22) != 0
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x5) != E_SImode
          || GET_MODE (x9) != E_SImode
          || !
#line 3880 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 583; /* *mulohisi3_call */

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case LSHIFTRT:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != MULT)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XEXP (x7, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x9) == E_HImode
              && pattern286 (x1, 
SIGN_EXTEND) == 0
              && 
#line 2282 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 306; /* *smulqi3_highpart */
          if (GET_MODE (x9) != E_SImode
              || pattern287 (x1, 
SIGN_EXTEND) != 0
              || !
#line 3800 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 572; /* *smulhi3_highpart_call_split */

        case ZERO_EXTEND:
          if (GET_MODE (x9) == E_HImode
              && pattern286 (x1, 
ZERO_EXTEND) == 0
              && 
#line 2282 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 307; /* *umulqi3_highpart */
          if (GET_MODE (x9) != E_SImode
              || pattern287 (x1, 
ZERO_EXTEND) != 0
              || !
#line 3800 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 573; /* *umulhi3_highpart_call_split */

        default:
          return -1;
        }

    case PARITY:
      if (pattern206 (x1, 
E_CCmode, 
36) != 0
          || !
#line 9243 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1030; /* *paritysihi2.libgcc */

    case POPCOUNT:
      if (pattern206 (x1, 
E_CCmode, 
36) != 0
          || !
#line 9319 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1035; /* *popcountsi2.libgcc */

    case CLZ:
      if (pattern206 (x1, 
E_QImode, 
26) != 0)
        return -1;
      return 1041; /* *clzsihi2.libgcc_split */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern99 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_HImode
          || !combine_pseudo_register_operand (operands[1], E_QImode)
          || !
#line 6452 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 807; /* *extendqihi2 */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!combine_pseudo_register_operand (operands[1], E_QImode)
              || !
#line 6473 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 809; /* *extendqipsi2 */

        case E_HImode:
          if (!combine_pseudo_register_operand (operands[1], E_HImode)
              || !
#line 6515 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 813; /* *extendhipsi2 */

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!combine_pseudo_register_operand (operands[1], E_QImode)
              || !
#line 6494 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 811; /* *extendqisi2 */

        case E_HImode:
          if (!combine_pseudo_register_operand (operands[1], E_HImode)
              || !
#line 6536 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 815; /* *extendhisi2 */

        case E_PSImode:
          if (!combine_pseudo_register_operand (operands[1], E_PSImode)
              || !
#line 6557 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 817; /* *extendpsisi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  if (!scratch_operand (operands[2], E_HImode))
    return -1;
  if (
#line 7929 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL))
    return 974; /* *tablejump_split */
  if (pnum_clobbers == NULL
      || !
#line 7950 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL && reload_completed))
    return -1;
  *pnum_clobbers = 1;
  return 975; /* *tablejump */
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 36
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !const_operand (operands[1], E_QImode)
          || !
#line 881 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 119; /* *reload_inqi */

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || !const_operand (operands[1], E_QQmode)
          || !
#line 881 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 120; /* *reload_inqq */

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || !const_operand (operands[1], E_UQQmode)
          || !
#line 881 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 121; /* *reload_inuqq */

    case E_HImode:
      if (!l_register_operand (operands[0], E_HImode)
          || !immediate_operand (operands[1], E_HImode)
          || !
#line 946 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 123; /* *reload_inhi */

    case E_HQmode:
      if (!l_register_operand (operands[0], E_HQmode)
          || !immediate_operand (operands[1], E_HQmode)
          || !
#line 946 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 124; /* *reload_inhq */

    case E_UHQmode:
      if (!l_register_operand (operands[0], E_UHQmode)
          || !immediate_operand (operands[1], E_UHQmode)
          || !
#line 946 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 125; /* *reload_inuhq */

    case E_HAmode:
      if (!l_register_operand (operands[0], E_HAmode)
          || !immediate_operand (operands[1], E_HAmode)
          || !
#line 946 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 126; /* *reload_inha */

    case E_UHAmode:
      if (!l_register_operand (operands[0], E_UHAmode)
          || !immediate_operand (operands[1], E_UHAmode)
          || !
#line 946 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 127; /* *reload_inuha */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !immediate_operand (operands[1], E_PSImode)
          || !
#line 1121 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 138; /* *reload_inpsi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !immediate_operand (operands[1], E_SImode)
          || !
#line 1178 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 141; /* *reload_insi */

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !immediate_operand (operands[1], E_SQmode)
          || !
#line 1178 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 142; /* *reload_insi */

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !immediate_operand (operands[1], E_USQmode)
          || !
#line 1178 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 143; /* *reload_insi */

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !immediate_operand (operands[1], E_SAmode)
          || !
#line 1178 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 144; /* *reload_insi */

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !immediate_operand (operands[1], E_USAmode)
          || !
#line 1178 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 145; /* *reload_insi */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !
#line 1279 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 159; /* *reload_insf */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LO_SUM
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 23
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_BLKmode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != UNSPEC
      || XVECLEN (x9, 0) != 1
      || XINT (x9, 1) != 1)
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x10) != USE)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 24
      || pattern27 (x1) != 0)
    return -1;
  x12 = XVECEXP (x1, 0, 6);
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 24
      || GET_MODE (x13) != E_HImode)
    return -1;
  x14 = XVECEXP (x1, 0, 7);
  if (pattern386 (x14, 
E_QImode, 
23) != 0)
    return -1;
  x15 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x15) != CLOBBER)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_CODE (x16) != MEM
      || GET_MODE (x16) != E_QImode)
    return -1;
  x17 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x17) != CLOBBER)
    return -1;
  x18 = XEXP (x17, 0);
  if (GET_CODE (x18) != REG
      || REGNO (x18) != 36
      || GET_MODE (x18) != E_CCmode)
    return -1;
  x19 = XVECEXP (x9, 0, 0);
  operands[0] = x19;
  if (!const_int_operand (operands[0], E_QImode))
    return -1;
  x20 = XEXP (x16, 0);
  operands[1] = x20;
  if (!io_address_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (x11))
    {
    case E_QImode:
      if (!
#line 1412 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 166; /* *cpymemx_qi */

    case E_HImode:
      if (!
#line 1412 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 167; /* *cpymemx_hi */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == REG)
    {
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      switch (REGNO (x2))
        {
        case 32:
          if (GET_MODE (x2) == E_HImode
              && register_operand (operands[0], E_HImode)
              && 
#line 537 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && frame_pointer_needed
   && !cfun->calls_alloca
   && find_reg_note (insn, REG_ARGS_SIZE, const0_rtx)
   && REGNO (operands[0]) != REG_Y))
            return gen_split_1 (insn, operands);
          break;

        case 22:
          switch (pattern159 (x2))
            {
            case 0:
              if ((
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_2 (insn, operands);
              break;

            case 1:
              if ((
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_3 (insn, operands);
              break;

            case 2:
              if ((
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_4 (insn, operands);
              break;

            case 3:
              if ((
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_5 (insn, operands);
              break;

            case 4:
              if ((
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_6 (insn, operands);
              break;

            case 5:
              if ((
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_7 (insn, operands);
              break;

            case 6:
              if ((
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_8 (insn, operands);
              break;

            case 7:
              if ((
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_9 (insn, operands);
              break;

            case 8:
              if ((
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_10 (insn, operands);
              break;

            case 9:
              if ((
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_11 (insn, operands);
              break;

            case 10:
              if ((
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_12 (insn, operands);
              break;

            case 11:
              if ((
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_13 (insn, operands);
              break;

            case 12:
              if ((
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_14 (insn, operands);
              break;

            case 13:
              if ((
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_15 (insn, operands);
              break;

            case 14:
              if ((
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))) && 
#line 576 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_16 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
    }
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern67 (x3))
    {
    case 0:
      if (!(
#line 848 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode)) && 
#line 851 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_62 (insn, operands);

    case 1:
      if (!(
#line 848 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(register_operand (operands[0], QQmode)
    || reg_or_0_operand (operands[1], QQmode)) && 
#line 851 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_63 (insn, operands);

    case 2:
      if (!(
#line 848 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(register_operand (operands[0], UQQmode)
    || reg_or_0_operand (operands[1], UQQmode)) && 
#line 851 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_64 (insn, operands);

    case 3:
      if (nonimmediate_operand (operands[0], E_HImode)
          && nox_general_operand (operands[1], E_HImode)
          && (
#line 959 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(register_operand (operands[0], HImode)
   || reg_or_0_operand (operands[1], HImode)) && 
#line 962 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_65 (insn, operands);
      if (!register_operand (operands[0], E_HImode)
          || !reg_or_0_operand (operands[1], E_HImode)
          || !
#line 4891 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed
   && GENERAL_REG_P (operands[0])
   && (operands[1] == const0_rtx || GENERAL_REG_P (operands[1]))
   && (!AVR_HAVE_MOVW
       || const0_rtx == operands[1])))
        return NULL;
      return gen_split_386 (insn, operands);

    case 4:
      if (!(
#line 959 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(register_operand (operands[0], HQmode)
   || reg_or_0_operand (operands[1], HQmode)) && 
#line 962 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_66 (insn, operands);

    case 5:
      if (!(
#line 959 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(register_operand (operands[0], UHQmode)
   || reg_or_0_operand (operands[1], UHQmode)) && 
#line 962 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_67 (insn, operands);

    case 6:
      if (!(
#line 959 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(register_operand (operands[0], HAmode)
   || reg_or_0_operand (operands[1], HAmode)) && 
#line 962 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_68 (insn, operands);

    case 7:
      if (!(
#line 959 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(register_operand (operands[0], UHAmode)
   || reg_or_0_operand (operands[1], UHAmode)) && 
#line 962 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_69 (insn, operands);

    case 8:
      if (nonimmediate_operand (operands[0], E_PSImode)
          && nox_general_operand (operands[1], E_PSImode)
          && (
#line 1131 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(register_operand (operands[0], PSImode)
   || register_operand (operands[1], PSImode)
   || const0_rtx == operands[1]) && 
#line 1135 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_85 (insn, operands);
      if (!register_operand (operands[0], E_PSImode)
          || !register_operand (operands[1], E_PSImode)
          || !
#line 4870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_381 (insn, operands);

    case 9:
      if (nonimmediate_operand (operands[0], E_SImode)
          && nox_general_operand (operands[1], E_SImode)
          && (
#line 1192 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(register_operand (operands[0], SImode)
   || reg_or_0_operand (operands[1], SImode)) && 
#line 1195 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_86 (insn, operands);
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_SImode)
          || !
#line 4870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_379 (insn, operands);

    case 10:
      if (nonimmediate_operand (operands[0], E_SQmode)
          && nox_general_operand (operands[1], E_SQmode)
          && (
#line 1192 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(register_operand (operands[0], SQmode)
   || reg_or_0_operand (operands[1], SQmode)) && 
#line 1195 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_87 (insn, operands);
      if (!register_operand (operands[0], E_SQmode)
          || !register_operand (operands[1], E_SQmode)
          || !
#line 4870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_382 (insn, operands);

    case 11:
      if (nonimmediate_operand (operands[0], E_USQmode)
          && nox_general_operand (operands[1], E_USQmode)
          && (
#line 1192 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(register_operand (operands[0], USQmode)
   || reg_or_0_operand (operands[1], USQmode)) && 
#line 1195 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_88 (insn, operands);
      if (!register_operand (operands[0], E_USQmode)
          || !register_operand (operands[1], E_USQmode)
          || !
#line 4870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_383 (insn, operands);

    case 12:
      if (nonimmediate_operand (operands[0], E_SAmode)
          && nox_general_operand (operands[1], E_SAmode)
          && (
#line 1192 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(register_operand (operands[0], SAmode)
   || reg_or_0_operand (operands[1], SAmode)) && 
#line 1195 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_89 (insn, operands);
      if (!register_operand (operands[0], E_SAmode)
          || !register_operand (operands[1], E_SAmode)
          || !
#line 4870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_384 (insn, operands);

    case 13:
      if (nonimmediate_operand (operands[0], E_USAmode)
          && nox_general_operand (operands[1], E_USAmode)
          && (
#line 1192 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(register_operand (operands[0], USAmode)
   || reg_or_0_operand (operands[1], USAmode)) && 
#line 1195 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_90 (insn, operands);
      if (!register_operand (operands[0], E_USAmode)
          || !register_operand (operands[1], E_USAmode)
          || !
#line 4870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_385 (insn, operands);

    case 14:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && nox_general_operand (operands[1], E_SFmode)
          && (
#line 1240 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(register_operand (operands[0], SFmode)
   || reg_or_0_operand (operands[1], SFmode)) && 
#line 1243 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return gen_split_91 (insn, operands);
      if (!register_operand (operands[0], E_SFmode)
          || !register_operand (operands[1], E_SFmode)
          || !
#line 4870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
        return NULL;
      return gen_split_380 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern13 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          x4 = XEXP (x1, 0);
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (pattern124 (x1, 
E_QImode) == 0
                  && 
#line 1579 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return gen_split_99 (insn, operands);
              break;

            case E_QQmode:
              if (pattern124 (x1, 
E_QQmode) == 0
                  && 
#line 1579 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return gen_split_100 (insn, operands);
              break;

            case E_UQQmode:
              if (pattern124 (x1, 
E_UQQmode) == 0
                  && 
#line 1579 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return gen_split_101 (insn, operands);
              break;

            case E_HImode:
              if (GET_MODE (x2) == E_HImode)
                {
                  operands[1] = x4;
                  if (stack_register_operand (operands[1], E_HImode))
                    {
                      x5 = XEXP (x2, 0);
                      operands[2] = x5;
                      if (stack_register_operand (operands[2], E_HImode))
                        {
                          operands[0] = x3;
                          if (avr_sp_immediate_operand (operands[0], E_HImode))
                            return gen_split_108 (insn, operands);
                        }
                    }
                  operands[0] = x4;
                  if (register_operand (operands[0], E_HImode))
                    {
                      x5 = XEXP (x2, 0);
                      operands[1] = x5;
                      if (register_operand (operands[1], E_HImode))
                        {
                          operands[2] = x3;
                          if (nonmemory_or_const_operand (operands[2], E_HImode))
                            return gen_split_109 (insn, operands);
                        }
                    }
                }
              break;

            case E_HQmode:
              if (pattern151 (x1, 
E_HQmode) == 0)
                return gen_split_110 (insn, operands);
              break;

            case E_UHQmode:
              if (pattern151 (x1, 
E_UHQmode) == 0)
                return gen_split_111 (insn, operands);
              break;

            case E_HAmode:
              if (pattern151 (x1, 
E_HAmode) == 0)
                return gen_split_112 (insn, operands);
              break;

            case E_UHAmode:
              if (pattern151 (x1, 
E_UHAmode) == 0)
                return gen_split_113 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case ZERO_EXTEND:
          if (pattern69 (x1) == 0
              && 
#line 1661 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_103 (insn, operands);
          break;

        default:
          break;
        }
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG)
        return NULL;
      switch (pattern72 (x1))
        {
        case 0:
          if (!(
#line 101 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1866 (insn, operands);

        case 1:
          if (!(
#line 101 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1867 (insn, operands);

        case 2:
          if (!(
#line 101 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1868 (insn, operands);

        case 3:
          if (!(
#line 101 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1869 (insn, operands);

        case 4:
          if (!(
#line 101 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1870 (insn, operands);

        case 5:
          if (!(
#line 101 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1871 (insn, operands);

        case 6:
          if (!(
#line 101 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 103 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1872 (insn, operands);

        case 7:
          if (!(
#line 122 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 124 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1873 (insn, operands);

        case 8:
          if (!(
#line 147 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1874 (insn, operands);

        case 9:
          if (!(
#line 147 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1875 (insn, operands);

        case 10:
          if (!(
#line 147 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1876 (insn, operands);

        case 11:
          if (!(
#line 147 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1877 (insn, operands);

        case 12:
          if (!(
#line 147 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1878 (insn, operands);

        case 13:
          if (!(
#line 147 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1879 (insn, operands);

        case 14:
          if (!(
#line 147 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)) && 
#line 150 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1880 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern3 (x2))
            {
            case 0:
              if (!
#line 1638 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_102 (insn, operands);

            case 1:
              if (!(
#line 1974 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 1
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_126 (insn, operands);

            case 2:
              if (!(
#line 1974 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 2
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_130 (insn, operands);

            case 3:
              if (!(
#line 1974 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 1
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_128 (insn, operands);

            case 4:
              if (!(
#line 1974 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 2
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_132 (insn, operands);

            case 5:
              if (!(
#line 1974 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 3
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_134 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
          operands[2] = x3;
          if (!const_m255_to_m1_operand (operands[2], E_HImode)
              || pattern189 (x2) != 0
              || !
#line 1682 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_104 (insn, operands);

        case ZERO_EXTEND:
          if (pattern161 (x2) != 0
              || !
#line 1750 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_106 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      if (!
#line 1721 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_105 (insn, operands);

    case 3:
      if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_911 (insn, operands);

    case 4:
      if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_917 (insn, operands);

    case 5:
      if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_929 (insn, operands);

    case 6:
      if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_923 (insn, operands);

    case 7:
      if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_935 (insn, operands);

    case 8:
      if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_941 (insn, operands);

    case 9:
      if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_910 (insn, operands);

    case 10:
      if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_916 (insn, operands);

    case 11:
      if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_928 (insn, operands);

    case 12:
      if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_922 (insn, operands);

    case 13:
      if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_934 (insn, operands);

    case 14:
      if (!(
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_940 (insn, operands);

    case 15:
      if (!(
#line 1974 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(2 > 1
   && (2 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_124 (insn, operands);

    case 16:
      if (!(
#line 1974 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 1
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_125 (insn, operands);

    case 17:
      if (!(
#line 1974 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 2
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_129 (insn, operands);

    case 18:
      if (!(
#line 1974 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 1
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_127 (insn, operands);

    case 19:
      if (!(
#line 1974 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 2
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_131 (insn, operands);

    case 20:
      if (!(
#line 1974 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 3
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)) && 
#line 1977 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_133 (insn, operands);

    case 21:
      if (!
#line 2316 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_174 (insn, operands);

    case 22:
      if (!
#line 2316 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_176 (insn, operands);

    case 23:
      if (!
#line 2316 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_178 (insn, operands);

    case 24:
      if (!
#line 2316 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_180 (insn, operands);

    case 25:
      if (!(
#line 2332 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(2 > 1) && 
#line 2334 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_182 (insn, operands);

    case 26:
      if (!(
#line 2332 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 1) && 
#line 2334 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_184 (insn, operands);

    case 27:
      if (!(
#line 2332 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 2) && 
#line 2334 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_188 (insn, operands);

    case 28:
      if (!(
#line 2332 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 1) && 
#line 2334 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_186 (insn, operands);

    case 29:
      if (!(
#line 2332 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 2) && 
#line 2334 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_190 (insn, operands);

    case 30:
      if (!(
#line 2332 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 3) && 
#line 2334 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_192 (insn, operands);

    case 31:
      if (!
#line 2316 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_175 (insn, operands);

    case 32:
      if (!
#line 2316 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_177 (insn, operands);

    case 33:
      if (!
#line 2316 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_179 (insn, operands);

    case 34:
      if (!
#line 2316 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_181 (insn, operands);

    case 35:
      if (!(
#line 2332 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(2 > 1) && 
#line 2334 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_183 (insn, operands);

    case 36:
      if (!(
#line 2332 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 1) && 
#line 2334 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_185 (insn, operands);

    case 37:
      if (!(
#line 2332 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 2) && 
#line 2334 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_189 (insn, operands);

    case 38:
      if (!(
#line 2332 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 1) && 
#line 2334 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_187 (insn, operands);

    case 39:
      if (!(
#line 2332 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 2) && 
#line 2334 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_191 (insn, operands);

    case 40:
      if (!(
#line 2332 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 3) && 
#line 2334 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_193 (insn, operands);

    case 41:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_206 (insn, operands);

    case 42:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_214 (insn, operands);

    case 43:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_222 (insn, operands);

    case 44:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_230 (insn, operands);

    case 45:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_208 (insn, operands);

    case 46:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_216 (insn, operands);

    case 47:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_224 (insn, operands);

    case 48:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_232 (insn, operands);

    case 49:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_210 (insn, operands);

    case 50:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_218 (insn, operands);

    case 51:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_226 (insn, operands);

    case 52:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_234 (insn, operands);

    case 53:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_212 (insn, operands);

    case 54:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_220 (insn, operands);

    case 55:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_228 (insn, operands);

    case 56:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_236 (insn, operands);

    case 57:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_207 (insn, operands);

    case 58:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_215 (insn, operands);

    case 59:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_223 (insn, operands);

    case 60:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_231 (insn, operands);

    case 61:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_209 (insn, operands);

    case 62:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_217 (insn, operands);

    case 63:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_225 (insn, operands);

    case 64:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_233 (insn, operands);

    case 65:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_211 (insn, operands);

    case 66:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_219 (insn, operands);

    case 67:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_227 (insn, operands);

    case 68:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_235 (insn, operands);

    case 69:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_213 (insn, operands);

    case 70:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_221 (insn, operands);

    case 71:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_229 (insn, operands);

    case 72:
      if (!
#line 2403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_237 (insn, operands);

    case 73:
      x2 = XEXP (x1, 1);
      x5 = XEXP (x2, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode
          || GET_MODE (x5) != E_QImode)
        return NULL;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_QImode))
        return NULL;
      x3 = XEXP (x2, 1);
      operands[3] = x3;
      if (!register_operand (operands[3], E_QImode)
          || !(
#line 2592 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2594 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_277 (insn, operands);

    case 74:
      x2 = XEXP (x1, 1);
      switch (pattern127 (x2))
        {
        case 0:
          x5 = XEXP (x2, 0);
          x7 = XEXP (x5, 1);
          if (GET_MODE (x7) != E_HImode
              || !register_operand (operands[3], E_HImode))
            return NULL;
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2701 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2703 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_281 (insn, operands);

            case ZERO_EXTEND:
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2759 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND) && 
#line 2763 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_286 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_874 (insn, operands);

        case 2:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_880 (insn, operands);

        case 3:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_892 (insn, operands);

        case 4:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_886 (insn, operands);

        case 5:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_898 (insn, operands);

        case 6:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_904 (insn, operands);

        default:
          return NULL;
        }

    case 75:
      x2 = XEXP (x1, 1);
      switch (pattern128 (x2))
        {
        case 0:
          if (!(
#line 2701 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2703 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_282 (insn, operands);

        case 1:
          if (!(
#line 2759 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND) && 
#line 2763 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_285 (insn, operands);

        case 2:
          x5 = XEXP (x2, 0);
          x7 = XEXP (x5, 1);
          if (XWINT (x7, 0) != 2L)
            return NULL;
          x3 = XEXP (x2, 1);
          operands[2] = x3;
          if (!(
#line 2832 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!reload_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])) && 
#line 2835 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_289 (insn, operands);

        case 3:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_875 (insn, operands);

        case 4:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_881 (insn, operands);

        case 5:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_893 (insn, operands);

        case 6:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_887 (insn, operands);

        case 7:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_899 (insn, operands);

        case 8:
          if (!(
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_905 (insn, operands);

        default:
          return NULL;
        }

    case 76:
      x2 = XEXP (x1, 1);
      switch (pattern129 (x2))
        {
        case 0:
          if (!(
#line 10757 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_862 (insn, operands);

        case 1:
          if (!(
#line 10757 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_865 (insn, operands);

        case 2:
          if (!(
#line 10757 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_868 (insn, operands);

        case 3:
          if (!(
#line 10757 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_871 (insn, operands);

        default:
          return NULL;
        }

    case 77:
      if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_814 (insn, operands);

    case 78:
      if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_826 (insn, operands);

    case 79:
      if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_838 (insn, operands);

    case 80:
      if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_850 (insn, operands);

    case 81:
      if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_817 (insn, operands);

    case 82:
      if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_829 (insn, operands);

    case 83:
      if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_841 (insn, operands);

    case 84:
      if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_853 (insn, operands);

    case 85:
      if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_820 (insn, operands);

    case 86:
      if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_832 (insn, operands);

    case 87:
      if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_844 (insn, operands);

    case 88:
      if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_856 (insn, operands);

    case 89:
      if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_823 (insn, operands);

    case 90:
      if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_835 (insn, operands);

    case 91:
      if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_847 (insn, operands);

    case 92:
      if (!(
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_859 (insn, operands);

    case 93:
      if (!(
#line 10813 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_946 (insn, operands);

    case 94:
      if (!(
#line 10813 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_949 (insn, operands);

    case 95:
      if (!(
#line 10813 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_952 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_28 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return NULL;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return NULL;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 18
      || GET_MODE (x7) != E_DImode)
    return NULL;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XEXP (x8, 0);
  operands[0] = x9;
  if (!pseudo_register_operand (operands[0], E_SImode))
    return NULL;
  x10 = XEXP (x8, 1);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!pseudo_register_operand (operands[1], E_SImode))
    return NULL;
  x12 = XEXP (x10, 1);
  operands[2] = x12;
  if (!pseudo_register_operand (operands[2], E_SImode)
      || !(
#line 3439 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && ! reload_completed) && 
#line 3444 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
    return NULL;
  return gen_split_313 (insn, operands);
}

 rtx_insn *
split_31 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return NULL;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return split_24 (x1, insn);

    case PLUS:
      return split_25 (x1, insn);

    case MINUS:
      return split_26 (x1, insn);

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != REG)
            return NULL;
          x7 = XEXP (x2, 0);
          if (GET_CODE (x7) != REG)
            return NULL;
          x8 = XEXP (x3, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          switch (REGNO (x5))
            {
            case 24:
              if (pattern281 (x1) != 0
                  || !(
#line 2239 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 2241 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_163 (insn, operands);

            case 22:
              if (pattern282 (x1) != 0
                  || !(
#line 3715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3717 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_335 (insn, operands);

            case 18:
              switch (pattern283 (x1))
                {
                case 0:
                  if (!(
#line 425 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1824 (insn, operands);

                case 1:
                  if (!(
#line 425 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1825 (insn, operands);

                case 2:
                  if (!(
#line 425 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1826 (insn, operands);

                case 3:
                  if (!(
#line 425 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1827 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (pattern182 (x1) != 0)
            return NULL;
          if (s8_operand (operands[2], E_HImode)
              && (
#line 2994 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2996 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_298 (insn, operands);
          if (u8_operand (operands[2], E_HImode)
              && (
#line 3030 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3032 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_301 (insn, operands);
          if (!o8_operand (operands[2], E_HImode)
              || !(
#line 3048 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3050 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_302 (insn, operands);

        case ZERO_EXTEND:
          if (pattern182 (x1) != 0)
            return NULL;
          if (u8_operand (operands[2], E_HImode)
              && (
#line 2994 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2996 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_299 (insn, operands);
          if (!s8_operand (operands[2], E_HImode)
              || !(
#line 3012 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3014 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_300 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      return split_27 (x1, insn);

    case TRUNCATE:
      if (GET_MODE (x4) != E_HImode
          || pattern183 (x1, 
E_HImode, 
24) != 0)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != MULT
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x10 = XEXP (x5, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return NULL;
          x8 = XEXP (x3, 0);
          if (REGNO (x8) != 22
              || GET_MODE (x8) != E_HImode)
            return NULL;
          switch (pattern358 (x9))
            {
            case 0:
              if (!(
#line 3800 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3802 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_339 (insn, operands);

            case 1:
              if (!(
#line 3800 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3802 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_340 (insn, operands);

            default:
              return NULL;
            }

        case CLZ:
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 22
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x8 = XEXP (x3, 0);
          if (REGNO (x8) != 26
              || GET_MODE (x8) != E_QImode
              || !
#line 9405 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_647 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 4509 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_368 (insn, operands);

        case 1:
          if (!
#line 4543 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_369 (insn, operands);

        case 2:
          if (!
#line 4578 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_370 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 4657 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_372 (insn, operands);

        case 1:
          if (!
#line 4689 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_373 (insn, operands);

        case 2:
          if (!
#line 4721 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_374 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 4778 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_376 (insn, operands);

        case 1:
          if (!
#line 4808 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_377 (insn, operands);

        case 2:
          if (!
#line 4840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_378 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return NULL;
      switch (pattern252 (x1))
        {
        case 0:
          if ((
#line 5232 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 2 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16) && 
#line 5237 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_403 (insn, operands);
          if (!(
#line 5255 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 2 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5261 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_405 (insn, operands);

        case 1:
          if (!(
#line 5232 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 4 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16) && 
#line 5237 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_404 (insn, operands);

        case 2:
          if (!(
#line 5255 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 4 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5261 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_407 (insn, operands);

        case 3:
          if (!(
#line 5255 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 3 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5261 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_406 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern253 (x1))
            {
            case 0:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_435 (insn, operands);
              break;

            case 1:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_438 (insn, operands);
              break;

            case 2:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3r (operands[2])))
                return gen_split_441 (insn, operands);
              break;

            case 3:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_444 (insn, operands);
              break;

            case 4:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_447 (insn, operands);
              break;

            case 5:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_450 (insn, operands);
              break;

            case 6:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_453 (insn, operands);
              break;

            case 7:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_456 (insn, operands);
              break;

            case 8:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_459 (insn, operands);
              break;

            case 9:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_462 (insn, operands);
              break;

            case 10:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_465 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern254 (x1) != 0
          || !
#line 6029 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_532 (insn, operands);

    case ASHIFTRT:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern253 (x1))
            {
            case 0:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_436 (insn, operands);
              break;

            case 1:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_439 (insn, operands);
              break;

            case 2:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3a (operands[2])))
                return gen_split_442 (insn, operands);
              break;

            case 3:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_445 (insn, operands);
              break;

            case 4:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_448 (insn, operands);
              break;

            case 5:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_451 (insn, operands);
              break;

            case 6:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_454 (insn, operands);
              break;

            case 7:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_457 (insn, operands);
              break;

            case 8:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_460 (insn, operands);
              break;

            case 9:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_463 (insn, operands);
              break;

            case 10:
              if (
#line 5591 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_466 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern254 (x1) != 0
          || !
#line 5829 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_511 (insn, operands);

    case LO_SUM:
      if (GET_MODE (x4) != E_PSImode
          || pattern171 (x1) != 0
          || !
#line 6634 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return NULL;
      return gen_split_560 (insn, operands);

    case COMPARE:
      if (GET_MODE (x4) != E_CCmode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LSHIFTRT)
        return NULL;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 36
          || GET_MODE (x7) != E_CCmode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != SCRATCH
          || GET_MODE (x8) != E_QImode)
        return NULL;
      switch (pattern323 (x5))
        {
        case 0:
          if (!(
#line 6908 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed) && 
#line 6912 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_566 (insn, operands);

        case 1:
          if (!(
#line 6908 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed) && 
#line 6912 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_567 (insn, operands);

        case 2:
          if (!(
#line 6908 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed) && 
#line 6912 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_568 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      x5 = XEXP (x4, 0);
      if (!ordered_comparison_operator (x5, E_VOIDmode))
        return NULL;
      operands[0] = x5;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return NULL;
      x11 = XEXP (x4, 2);
      if (GET_CODE (x11) != PC)
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != PC)
        return NULL;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      switch (pattern289 (x1))
        {
        case 0:
          if (
#line 7016 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_572 (insn, operands);
          break;

        case 1:
          if (
#line 7016 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_573 (insn, operands);
          break;

        case 2:
          if (
#line 7016 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_574 (insn, operands);
          break;

        case 3:
          if (
#line 7016 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_575 (insn, operands);
          break;

        case 4:
          if (
#line 7016 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_576 (insn, operands);
          break;

        case 5:
          if (
#line 7043 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_577 (insn, operands);
          break;

        case 6:
          if (
#line 7071 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_578 (insn, operands);
          break;

        case 7:
          if (
#line 7071 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_579 (insn, operands);
          break;

        case 8:
          if (
#line 7071 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_580 (insn, operands);
          break;

        case 9:
          if (
#line 7071 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_581 (insn, operands);
          break;

        case 10:
          if (
#line 7071 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_582 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x9) != REG)
        return NULL;
      switch (pattern290 (x1))
        {
        case 0:
          if (!(
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1928 (insn, operands);

        case 1:
          if (!(
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1929 (insn, operands);

        case 2:
          if (!(
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1930 (insn, operands);

        case 3:
          if (!(
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1931 (insn, operands);

        case 4:
          if (!(
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1932 (insn, operands);

        case 5:
          if (!(
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1933 (insn, operands);

        case 6:
          if (!(
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1934 (insn, operands);

        default:
          return NULL;
        }

    case PARITY:
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24)
        return NULL;
      switch (pattern225 (x1))
        {
        case 0:
          if (!(
#line 9140 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9142 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_635 (insn, operands);

        case 1:
          if (!(
#line 9169 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9171 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_637 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PARITY
          || GET_MODE (x5) != E_QImode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24
          || GET_MODE (x8) != E_HImode)
        return NULL;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_HImode))
        return NULL;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_QImode)
          || !(
#line 9155 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9157 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_636 (insn, operands);

    case CLZ:
      if (pattern156 (x1) != 0
          || !
#line 9384 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_646 (insn, operands);

    case CTZ:
      if (pattern156 (x1) != 0
          || !
#line 9453 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_648 (insn, operands);

    case FFS:
      if (pattern156 (x1) != 0
          || !
#line 9525 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_650 (insn, operands);

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2)
        return NULL;
      x12 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x12) != REG)
        return NULL;
      x13 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x13) != REG
          || GET_MODE (x13) != E_QImode)
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG)
        return NULL;
      switch (pattern293 (x1))
        {
        case 0:
          if (!(
#line 9729 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_654 (insn, operands);

        case 1:
          if (!(
#line 9801 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9803 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_656 (insn, operands);

        case 2:
          if (!(
#line 9873 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9875 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_658 (insn, operands);

        case 3:
          if (!
#line 716 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1856 (insn, operands);

        case 4:
          if (!
#line 716 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1857 (insn, operands);

        case 5:
          if (!
#line 742 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1858 (insn, operands);

        case 6:
          if (!
#line 742 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1859 (insn, operands);

        case 7:
          if (!
#line 742 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1860 (insn, operands);

        case 8:
          if (!
#line 742 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1861 (insn, operands);

        case 9:
          if (!
#line 768 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1862 (insn, operands);

        case 10:
          if (!
#line 768 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1863 (insn, operands);

        case 11:
          if (!
#line 768 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1864 (insn, operands);

        case 12:
          if (!
#line 768 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1865 (insn, operands);

        default:
          return NULL;
        }

    case UDIV:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 516 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1830 (insn, operands);

        case 1:
          if (!
#line 516 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1832 (insn, operands);

        default:
          return NULL;
        }

    case DIV:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 516 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1831 (insn, operands);

        case 1:
          if (!
#line 516 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1833 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
