/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[4], E_QImode)
          || !single_one_operand (operands[2], E_HImode)
          || !register_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || GET_MODE (x2) != E_PSImode
          || GET_MODE (x3) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[4], E_QImode)
          || !single_one_operand (operands[2], E_PSImode)
          || !register_operand (operands[3], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[4], E_QImode)
          || !single_one_operand (operands[2], E_SImode)
          || !register_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 30
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 26
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != 1
      || XINT (x7, 1) != 1)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != USE
      || pattern27 (x1) != 0)
    return -1;
  return 0;
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern32 (x2, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern32 (x2, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern32 (x2, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern32 (x2, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  return pattern43 (x2); /* [-1, 0] */
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTEND
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_PSImode)
      || GET_MODE (x2) != E_PSImode)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[1] = x5;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || GET_MODE (x5) != E_UDQmode)
            return -1;
          return 0;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || GET_MODE (x5) != E_UDAmode)
            return -1;
          return 1;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || GET_MODE (x5) != E_UTAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || !const_operand (operands[0], E_UDQmode))
            return -1;
          return 3;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || !const_operand (operands[0], E_UDAmode))
            return -1;
          return 4;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || !const_operand (operands[0], E_UTAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  return pattern76 (x1); /* [-1, 3] */
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          return pattern79 (x1, 
E_HImode); /* [-1, 0] */

        case E_PSImode:
          if (pattern79 (x1, 
E_PSImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern79 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_QImode:
          if (pattern80 (x1) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      res = pattern47 (x1);
      if (res >= 0)
        return res + 4; /* [4, 9] */
      return -1;

    case XOR:
      if (GET_MODE (x3) != E_QImode
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || GET_MODE (x2) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[4] = x5;
      if (!const_int_operand (operands[4], E_QImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!const_0_to_7_operand (operands[2], E_QImode))
        return -1;
      x7 = XEXP (x1, 1);
      operands[3] = x7;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x7 = XEXP (x4, 2);
  operands[1] = x7;
  if (!const_0_to_7_operand (operands[1], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[4] = x9;
  if (!const_int_operand (operands[4], E_QImode))
    return -1;
  x10 = XEXP (x2, 2);
  operands[3] = x10;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x6) != E_QQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 0;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 1;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 2;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 3;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 4;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 5;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 6;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 7;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 8;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 9;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 10;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 11;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 12;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 13;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 14;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 15;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 16;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 17;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x6) != E_UQQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 19;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 20;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 21;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 22;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 23;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 24;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 25;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 26;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 27;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 28;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 29;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 30;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 31;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 32;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 33;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 34;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 35;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 36;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 37;

        default:
          return -1;
        }

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x6) != E_HQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 38;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 39;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 40;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 41;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 42;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 43;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 44;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 45;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 46;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 47;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 48;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 49;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 50;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 51;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 52;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 53;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 54;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 55;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x6) != E_UHQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 57;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 58;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 59;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 60;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 61;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 62;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 63;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 64;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 65;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 66;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 67;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 68;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 69;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 70;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 71;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 72;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 73;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 74;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 75;

        default:
          return -1;
        }

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x6) != E_HAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 76;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 77;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 78;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 79;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 80;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 81;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 82;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 83;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 84;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 85;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 86;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 87;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 88;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 89;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 90;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 91;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 92;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 93;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 94;

        default:
          return -1;
        }

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x6) != E_UHAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 95;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 96;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 97;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 98;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 99;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 100;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 101;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 102;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 103;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 104;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 105;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 106;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 107;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 108;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 109;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 110;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 111;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 112;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 113;

        default:
          return -1;
        }

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x6) != E_SQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 114;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 115;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 116;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 117;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 118;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 119;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 120;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 121;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 122;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 123;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 124;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 125;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 126;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 127;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 128;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 129;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 130;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 131;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 132;

        default:
          return -1;
        }

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x6) != E_USQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 133;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 134;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 135;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 136;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 137;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 138;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 139;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 140;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 141;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 142;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 143;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 144;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 145;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 146;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 147;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 148;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 149;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 150;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 151;

        default:
          return -1;
        }

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x6) != E_SAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 152;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 153;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 154;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 155;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 156;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 157;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 158;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 159;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 160;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 161;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 162;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 163;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 164;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 165;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 166;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 167;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 168;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 169;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 170;

        default:
          return -1;
        }

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x6) != E_USAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 171;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 172;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 173;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 174;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 175;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 176;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 177;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 178;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 179;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 180;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 181;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 182;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 183;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 184;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 185;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 186;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 187;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 188;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 189;

        default:
          return -1;
        }

    case E_DQmode:
      if (!register_operand (operands[0], E_DQmode)
          || GET_MODE (x6) != E_DQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 190;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 191;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 192;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 193;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 194;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 195;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 196;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 197;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 198;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 199;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 200;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 201;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 202;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 203;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 204;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 205;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 206;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 207;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 208;

        default:
          return -1;
        }

    case E_UDQmode:
      if (!register_operand (operands[0], E_UDQmode)
          || GET_MODE (x6) != E_UDQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 209;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 210;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 211;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 212;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 213;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 214;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 215;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 216;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 217;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 218;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 219;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 220;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 221;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 222;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 223;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 224;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 225;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 226;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 227;

        default:
          return -1;
        }

    case E_DAmode:
      if (!register_operand (operands[0], E_DAmode)
          || GET_MODE (x6) != E_DAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 228;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 229;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 230;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 231;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 232;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 233;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 234;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 235;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 236;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 237;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 238;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 239;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 240;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 241;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 242;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 243;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 244;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 245;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 246;

        default:
          return -1;
        }

    case E_UDAmode:
      if (!register_operand (operands[0], E_UDAmode)
          || GET_MODE (x6) != E_UDAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 247;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 248;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 249;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 250;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 251;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 252;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 253;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 254;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 255;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 256;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 257;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 258;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 259;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 260;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 261;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 262;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 263;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 264;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 265;

        default:
          return -1;
        }

    case E_TAmode:
      if (!register_operand (operands[0], E_TAmode)
          || GET_MODE (x6) != E_TAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 266;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 267;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 268;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 269;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 270;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 271;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 272;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 273;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 274;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 275;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 276;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 277;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 278;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 279;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 280;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 281;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 282;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 283;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 284;

        default:
          return -1;
        }

    case E_UTAmode:
      if (!register_operand (operands[0], E_UTAmode)
          || GET_MODE (x6) != E_UTAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 285;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 286;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 287;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 288;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 289;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 290;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 291;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 292;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 293;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 294;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 295;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 296;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 297;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 298;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 299;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 300;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 301;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 302;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 303;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x6) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 304;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 305;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 306;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 307;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 308;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 309;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 310;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 311;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 312;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 313;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 314;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 315;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 316;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 317;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 318;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 319;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 320;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 321;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 322;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x6) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 323;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 324;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 325;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 326;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 327;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 328;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 329;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 330;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 331;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 332;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 333;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 334;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 335;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 336;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 337;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 338;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 339;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 340;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 341;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 342;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 343;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 344;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 345;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 346;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 347;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 348;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 349;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 350;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 351;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 352;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 353;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 354;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 355;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 356;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 357;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 358;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 359;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 360;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x6) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 361;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 362;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 363;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 364;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 365;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 366;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 367;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 368;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 369;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 370;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 371;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 372;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 373;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 374;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 375;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 376;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 377;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 378;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 379;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      switch (pattern54 (x1, pnum_clobbers))
        {
        case 0:
          return 743; /* *lshrqi3_split */

        case 1:
          return 744; /* *lshrqq3_split */

        case 2:
          return 745; /* *lshruqq3_split */

        case 3:
          if (nop_general_operand (operands[2], E_QImode))
            return 749; /* lshrhi3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6148 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 771; /* *lshrhi3_const */
            }
          break;

        case 4:
          if (nop_general_operand (operands[2], E_QImode))
            return 750; /* lshrhq3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6148 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 772; /* *lshrhq3_const */
            }
          break;

        case 5:
          if (nop_general_operand (operands[2], E_QImode))
            return 751; /* lshruhq3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6148 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 773; /* *lshruhq3_const */
            }
          break;

        case 6:
          if (nop_general_operand (operands[2], E_QImode))
            return 752; /* lshrha3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6148 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 774; /* *lshrha3_const */
            }
          break;

        case 7:
          if (nop_general_operand (operands[2], E_QImode))
            return 753; /* lshruha3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6148 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 775; /* *lshruha3_const */
            }
          break;

        case 8:
          *pnum_clobbers = 1;
          return 759; /* lshrpsi3 */

        case 9:
          return 761; /* lshrsi3 */

        case 10:
          return 762; /* lshrsq3 */

        case 11:
          return 763; /* lshrusq3 */

        case 12:
          return 764; /* lshrsa3 */

        case 13:
          return 765; /* lshrusa3 */

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      if (pattern55 (x1) == 0)
        return 1082; /* *insv.shiftrt */
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) == E_QImode)
    {
      x4 = XEXP (x3, 1);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 7])
        {
          operands[0] = x2;
          if (register_operand (operands[0], E_QImode))
            {
              x5 = XEXP (x3, 0);
              operands[1] = x5;
              if (reg_or_low_io_operand (operands[1], E_QImode)
                  && 
#line 10560 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed))
                return 1181; /* *extzv.io.lsr7 */
            }
        }
    }
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  switch (pattern56 (x1))
    {
    case 0:
      if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3306; /* lshrdi3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3334; /* *lshrdi3_insn */

    case 1:
      if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3310; /* lshrdq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3338; /* *lshrdq3_insn */

    case 2:
      if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3314; /* lshrudq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3342; /* *lshrudq3_insn */

    case 3:
      if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3318; /* lshrda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3346; /* *lshrda3_insn */

    case 4:
      if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3322; /* lshruda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3350; /* *lshruda3_insn */

    case 5:
      if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3326; /* lshrta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3354; /* *lshrta3_insn */

    case 6:
      if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3330; /* lshruta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3358; /* *lshruta3_insn */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_18 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != REG)
        return -1;
      switch (pattern56 (x1))
        {
        case 0:
          if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3307; /* rotldi3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3335; /* *rotldi3_insn */

        case 1:
          if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3311; /* rotldq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3339; /* *rotldq3_insn */

        case 2:
          if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3315; /* rotludq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3343; /* *rotludq3_insn */

        case 3:
          if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3319; /* rotlda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3347; /* *rotlda3_insn */

        case 4:
          if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3323; /* rotluda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3351; /* *rotluda3_insn */

        case 5:
          if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3327; /* rotlta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3355; /* *rotlta3_insn */

        case 6:
          if (
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3331; /* rotluta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3359; /* *rotluta3_insn */

        default:
          return -1;
        }

    case CONST_INT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      switch (XWINT (x3, 0))
        {
        case 1L:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_QImode)
              || !
#line 8976 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 1014; /* *mask1_0x01 */

        case -2L:
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              if (GET_MODE (x5) != E_QImode)
                return -1;
              x6 = XEXP (x5, 1);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
                return -1;
              x7 = XEXP (x5, 0);
              operands[1] = x7;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 1018; /* mask1_0xfe_split */

            case REG:
            case SUBREG:
              if (pnum_clobbers == NULL)
                return -1;
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode)
                  || !
#line 9052 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 1019; /* *mask1_0xfe */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LO_SUM
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) == 30
      && GET_MODE (x7) == E_HImode)
    {
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (register_operand (operands[1], E_QImode))
        {
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (register_operand (operands[0], E_QImode)
                  && GET_MODE (x3) == E_QImode
                  && 
#line 655 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
                return 53; /* fmovqi */
              break;

            case E_QQmode:
              if (register_operand (operands[0], E_QQmode)
                  && GET_MODE (x3) == E_QQmode
                  && 
#line 655 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
                return 54; /* fmovqq */
              break;

            case E_UQQmode:
              if (register_operand (operands[0], E_UQQmode)
                  && GET_MODE (x3) == E_UQQmode
                  && 
#line 655 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
                return 55; /* fmovuqq */
              break;

            case E_HImode:
              if (register_operand (operands[0], E_HImode)
                  && GET_MODE (x3) == E_HImode
                  && 
#line 655 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
                return 56; /* fmovhi */
              break;

            case E_HQmode:
              if (register_operand (operands[0], E_HQmode)
                  && GET_MODE (x3) == E_HQmode
                  && 
#line 655 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
                return 57; /* fmovhq */
              break;

            case E_UHQmode:
              if (register_operand (operands[0], E_UHQmode)
                  && GET_MODE (x3) == E_UHQmode
                  && 
#line 655 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
                return 58; /* fmovuhq */
              break;

            case E_HAmode:
              if (register_operand (operands[0], E_HAmode)
                  && GET_MODE (x3) == E_HAmode
                  && 
#line 655 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
                return 59; /* fmovha */
              break;

            case E_UHAmode:
              if (register_operand (operands[0], E_UHAmode)
                  && GET_MODE (x3) == E_UHAmode
                  && 
#line 655 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
                return 60; /* fmovuha */
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && GET_MODE (x3) == E_SImode
                  && 
#line 655 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
                return 61; /* fmovsi */
              break;

            case E_SQmode:
              if (register_operand (operands[0], E_SQmode)
                  && GET_MODE (x3) == E_SQmode
                  && 
#line 655 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
                return 62; /* fmovsq */
              break;

            case E_USQmode:
              if (register_operand (operands[0], E_USQmode)
                  && GET_MODE (x3) == E_USQmode
                  && 
#line 655 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
                return 63; /* fmovusq */
              break;

            case E_SAmode:
              if (register_operand (operands[0], E_SAmode)
                  && GET_MODE (x3) == E_SAmode
                  && 
#line 655 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
                return 64; /* fmovsa */
              break;

            case E_USAmode:
              if (register_operand (operands[0], E_USAmode)
                  && GET_MODE (x3) == E_USAmode
                  && 
#line 655 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
                return 65; /* fmovusa */
              break;

            case E_SFmode:
              if (register_operand (operands[0], E_SFmode)
                  && GET_MODE (x3) == E_SFmode
                  && 
#line 655 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
                return 66; /* fmovsf */
              break;

            case E_PSImode:
              if (register_operand (operands[0], E_PSImode)
                  && GET_MODE (x3) == E_PSImode
                  && 
#line 655 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
                return 67; /* fmovpsi */
              break;

            default:
              break;
            }
        }
    }
  x9 = XEXP (x4, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 21
      || GET_MODE (x9) != E_QImode)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 22
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  switch (pattern363 (x2))
    {
    case 0:
      if (!
#line 731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      return 98; /* *fxload_qi_libgcc */

    case 1:
      if (!
#line 731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      return 99; /* *fxload_qq_libgcc */

    case 2:
      if (!
#line 731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      return 100; /* *fxload_uqq_libgcc */

    case 3:
      if (!
#line 731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      return 101; /* *fxload_hi_libgcc */

    case 4:
      if (!
#line 731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      return 102; /* *fxload_hq_libgcc */

    case 5:
      if (!
#line 731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      return 103; /* *fxload_uhq_libgcc */

    case 6:
      if (!
#line 731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      return 104; /* *fxload_ha_libgcc */

    case 7:
      if (!
#line 731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      return 105; /* *fxload_uha_libgcc */

    case 8:
      if (!
#line 731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      return 106; /* *fxload_si_libgcc */

    case 9:
      if (!
#line 731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      return 107; /* *fxload_sq_libgcc */

    case 10:
      if (!
#line 731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      return 108; /* *fxload_usq_libgcc */

    case 11:
      if (!
#line 731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      return 109; /* *fxload_sa_libgcc */

    case 12:
      if (!
#line 731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      return 110; /* *fxload_usa_libgcc */

    case 13:
      if (!
#line 731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      return 111; /* *fxload_sf_libgcc */

    case 14:
      if (!
#line 731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
        return -1;
      return 112; /* *fxload_psi_libgcc */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern100 (x2, 
36, 
E_CCmode) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (register_operand (operands[0], E_QImode)
              && GET_MODE (x4) == E_QImode
              && register_operand (operands[1], E_QImode)
              && 
#line 6232 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 786; /* *negqi2 */
          break;

        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && GET_MODE (x4) == E_HImode
              && register_operand (operands[1], E_HImode)
              && 
#line 6268 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 790; /* *neghi2 */
          break;

        case E_PSImode:
          if (register_operand (operands[0], E_PSImode)
              && GET_MODE (x4) == E_PSImode
              && register_operand (operands[1], E_PSImode)
              && 
#line 6288 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 792; /* *negpsi2 */
          break;

        case E_SFmode:
          if (register_operand (operands[0], E_SFmode)
              && GET_MODE (x4) == E_SFmode
              && register_operand (operands[1], E_SFmode)
              && 
#line 6343 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 797; /* *negsf2 */
          break;

        default:
          break;
        }
      if (GET_CODE (x5) == REG
          && GET_CODE (x6) == REG)
        {
          switch (REGNO (x5))
            {
            case 22:
              if (pattern302 (x3, 
E_SImode, 
22) == 0
                  && 
#line 6311 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && optimize_size))
                return 794; /* *negsi2.libgcc */
              break;

            case 18:
              if (pattern302 (x3, 
E_DImode, 
18) == 0
                  && 
#line 432 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return 3273; /* *negdi2_insn */
              break;

            default:
              break;
            }
        }
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode
          || !
#line 6320 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 795; /* *negsi2 */

    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x4) != E_HImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode)
          || !
#line 6250 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 788; /* *negqihi2 */

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern100 (x2, 
36, 
E_CCmode) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x4) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 6366 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 799; /* *one_cmplqi2 */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 6384 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 801; /* *one_cmplhi2 */

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x4) != E_PSImode
              || !register_operand (operands[1], E_PSImode)
              || !
#line 6403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 803; /* *one_cmplpsi2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !
#line 6421 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 805; /* *one_cmplsi2 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_QImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != ZERO_EXTRACT
          || GET_MODE (x6) != E_QImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x10 = XEXP (x6, 2);
      operands[1] = x10;
      if (!const_0_to_7_operand (operands[1], E_QImode)
          || GET_MODE (x4) != E_QImode)
        return -1;
      x11 = XEXP (x5, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x12 = XEXP (x5, 2);
      operands[3] = x12;
      if (!const_0_to_7_operand (operands[3], E_QImode)
          || !
#line 10055 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1084; /* insv_notbit */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (nonmemory_operand (operands[2], E_QImode)
          && pattern262 (x1, 
E_QImode) == 0
          && 
#line 4493 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return 619; /* *andqi3 */
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      switch (pattern109 (x4))
        {
        case 0:
          return 620; /* andhi3 */

        case 1:
          return 622; /* andpsi3 */

        case 2:
          return 624; /* andsi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 10595 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1194; /* *insv.any_shift.qi */

        case 1:
          if (!
#line 10595 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1197; /* *insv.any_shift.hi */

        case 2:
          if (!
#line 10595 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1200; /* *insv.any_shift.psi */

        case 3:
          if (!
#line 10595 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1203; /* *insv.any_shift.si */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 10595 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1195; /* *insv.any_shift.qi */

        case 1:
          if (!
#line 10595 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1198; /* *insv.any_shift.hi */

        case 2:
          if (!
#line 10595 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1201; /* *insv.any_shift.psi */

        case 3:
          if (!
#line 10595 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1204; /* *insv.any_shift.si */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 10595 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1196; /* *insv.any_shift.qi */

        case 1:
          if (!
#line 10595 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1199; /* *insv.any_shift.hi */

        case 2:
          if (!
#line 10595 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1202; /* *insv.any_shift.psi */

        case 3:
          if (!
#line 10595 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1205; /* *insv.any_shift.si */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern97 (x1))
        {
        case 0:
          if (!
#line 10970 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1478; /* *nzb=1.and.zerox */

        case 1:
          if (!
#line 11090 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1493; /* *nzb=1.and.zerox.not */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 0);
  switch (REGNO (x6))
    {
    case 24:
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      if (REGNO (x8) != 22)
        return -1;
      x9 = XVECEXP (x1, 0, 3);
      x10 = XEXP (x9, 0);
      if (REGNO (x10) != 36
          || GET_MODE (x10) != E_CCmode)
        return -1;
      switch (pattern338 (x1))
        {
        case 0:
          if (!
#line 3330 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          return 540; /* *mulhi3_call */

        case 1:
          if (!
#line 394 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3081; /* *mulqq3.call */

        default:
          return -1;
        }

    case 22:
      if (REGNO (x4) != 18
          || REGNO (x5) != 22)
        return -1;
      x9 = XVECEXP (x1, 0, 3);
      x10 = XEXP (x9, 0);
      if (GET_MODE (x10) != E_HImode)
        return -1;
      switch (pattern360 (x1))
        {
        case 0:
          if (!
#line 3731 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY))
            return -1;
          return 565; /* *mulsi3_call_pr118012_split */

        case 1:
          if (!
#line 4249 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 604; /* *mulpsi3.libgcc_split */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case SUBREG:
        case MEM:
          switch (pattern172 (x1))
            {
            case 0:
              if (!
#line 674 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 68; /* fxloadqi_A */

            case 1:
              if (!
#line 674 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 69; /* fxloadqq_A */

            case 2:
              if (!
#line 674 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 70; /* fxloaduqq_A */

            case 3:
              if (!
#line 674 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 71; /* fxloadhi_A */

            case 4:
              if (!
#line 674 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 72; /* fxloadhq_A */

            case 5:
              if (!
#line 674 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 73; /* fxloaduhq_A */

            case 6:
              if (!
#line 674 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 74; /* fxloadha_A */

            case 7:
              if (!
#line 674 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 75; /* fxloaduha_A */

            case 8:
              if (!
#line 674 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 76; /* fxloadsi_A */

            case 9:
              if (!
#line 674 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 77; /* fxloadsq_A */

            case 10:
              if (!
#line 674 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 78; /* fxloadusq_A */

            case 11:
              if (!
#line 674 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 79; /* fxloadsa_A */

            case 12:
              if (!
#line 674 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 80; /* fxloadusa_A */

            case 13:
              if (!
#line 674 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 81; /* fxloadsf_A */

            case 14:
              if (!
#line 674 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 82; /* fxloadpsi_A */

            default:
              return -1;
            }

        case MULT:
          if (pattern173 (x1) != 0)
            return -1;
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG)
                return -1;
              x8 = XEXP (x5, 1);
              if (GET_CODE (x8) != ZERO_EXTEND)
                return -1;
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != REG)
                return -1;
              x10 = XEXP (x2, 0);
              if (GET_CODE (x10) != REG)
                return -1;
              x11 = XEXP (x4, 0);
              if (REGNO (x11) != 36
                  || GET_MODE (x11) != E_CCmode)
                return -1;
              switch (pattern266 (x1))
                {
                case 0:
                  if (!
#line 2454 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
                    return -1;
                  return 477; /* *umulqihi3.call */

                case 1:
                  if (!
#line 693 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL
   && reload_completed))
                    return -1;
                  return 3363; /* *umulsidi3_insn */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (GET_CODE (x6) == REG)
                {
                  res = recog_74 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[1] = x6;
              if (!pseudo_register_operand (operands[1], E_SImode)
                  || pattern309 (x1, 
E_HImode, 
30, 
26) != 0)
                return -1;
              x11 = XEXP (x4, 0);
              if (REGNO (x11) != 18
                  || GET_MODE (x11) != E_DImode)
                return -1;
              x10 = XEXP (x2, 0);
              operands[0] = x10;
              if (!pseudo_register_operand (operands[0], E_SImode)
                  || GET_MODE (x5) != E_SImode)
                return -1;
              x8 = XEXP (x5, 1);
              operands[2] = x8;
              if (!pseudo_register_operand (operands[2], E_SImode)
                  || !
#line 3439 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && ! reload_completed))
                return -1;
              return 542; /* *mulsi3_pr118012 */

            case SIGN_EXTEND:
              if (GET_MODE (x6) != E_DImode)
                return -1;
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 18
                  || pattern298 (x5, 
E_SImode, 
22, 
E_DImode) != 0)
                return -1;
              x10 = XEXP (x2, 0);
              if (GET_CODE (x10) != REG
                  || pattern260 (x1, 
26, 
E_DImode, 
18, 
E_HImode) != 0
                  || pattern240 (x1, 
E_DImode, 
E_CCmode, 
36, 
30) != 0
                  || !
#line 693 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL
   && reload_completed))
                return -1;
              return 3362; /* *mulsidi3_insn */

            default:
              return -1;
            }

        case DIV:
          x12 = XEXP (x3, 0);
          if (GET_CODE (x12) != REG)
            return -1;
          x11 = XEXP (x4, 0);
          if (GET_CODE (x11) != REG)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) == REG)
            {
              res = recog_75 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (REGNO (x11) != 26
              || pattern243 (x1, 
MOD) != 0)
            return -1;
          return 606; /* divmodpsi4 */

        case UDIV:
          x12 = XEXP (x3, 0);
          if (GET_CODE (x12) != REG)
            return -1;
          x11 = XEXP (x4, 0);
          if (GET_CODE (x11) != REG)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) == REG)
            {
              res = recog_76 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (REGNO (x11) != 26
              || pattern243 (x1, 
UMOD) != 0)
            return -1;
          return 609; /* udivmodpsi4 */

        case UNSPEC:
          if (pattern119 (x1) != 0)
            return -1;
          x11 = XEXP (x4, 0);
          if (x11 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              res = recog_77 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x13 = XVECEXP (x5, 0, 0);
          if (GET_CODE (x13) != REG
              || pattern325 (x1) != 0
              || !
#line 7965 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_EIJMP_EICALL))
            return -1;
          return 976; /* *tablejump.3byte-pc_split */

        case TRUNCATE:
          if (GET_MODE (x5) != E_HImode)
            return -1;
          x10 = XEXP (x2, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 24
              || GET_MODE (x10) != E_HImode)
            return -1;
          x14 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x14) != CLOBBER)
            return -1;
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != REG
              || REGNO (x15) != 22
              || GET_MODE (x15) != E_QImode)
            return -1;
          x12 = XEXP (x3, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 26
              || GET_MODE (x12) != E_QImode)
            return -1;
          x11 = XEXP (x4, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 36
              || GET_MODE (x11) != E_CCmode)
            return -1;
          x6 = XEXP (x5, 0);
          switch (pattern353 (x6))
            {
            case 0:
              if (!
#line 9488 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1046; /* *ctzsihi2.libgcc */

            case 1:
              if (!
#line 9560 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1050; /* *ffssihi2.libgcc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x2, 0))
        {
        case 1:
          if (pnum_clobbers == NULL
              || pattern149 (x1) != 0)
            return -1;
          x3 = XVECEXP (x1, 0, 2);
          x12 = XEXP (x3, 0);
          if (GET_MODE (x12) != E_HImode)
            return -1;
          x4 = XVECEXP (x1, 0, 3);
          if (pattern210 (x4, 
E_HImode, 
26, 
USE) != 0)
            return -1;
          x14 = XVECEXP (x1, 0, 1);
          operands[0] = x14;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x16 = XEXP (x3, 1);
          x17 = XEXP (x16, 1);
          operands[1] = x17;
          if (!immediate_operand (operands[1], E_HImode))
            return -1;
          *pnum_clobbers = 2;
          return 996; /* call_prologue_saves */

        case 2:
          x14 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x14) != SET)
            return -1;
          x18 = XEXP (x14, 1);
          if (GET_CODE (x18) != UNSPEC_VOLATILE
              || XVECLEN (x18, 0) != 1)
            return -1;
          x4 = XVECEXP (x1, 0, 3);
          if (pattern210 (x4, 
E_CCmode, 
36, 
CLOBBER) != 0)
            return -1;
          x19 = XVECEXP (x2, 0, 0);
          operands[0] = x19;
          switch (XINT (x2, 1))
            {
            case 3:
              if (pattern279 (x1) != 0
                  || !
#line 8673 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_gasisr_prologues))
                return -1;
              return 998; /* *gasisr */

            case 10:
              switch (pattern246 (x1))
                {
                case 0:
                  if (!
#line 8764 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 1004; /* *delay_cycles_1 */

                case 1:
                  if (!
#line 8798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 1006; /* *delay_cycles_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  if (pattern126 (x3) != 0)
    return NULL;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QImode))
    return NULL;
  x8 = XEXP (x3, 1);
  switch (pattern280 (x8))
    {
    case 0:
      if (!(
#line 2538 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2540 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_275 (insn, operands);

    case 1:
      if (!(
#line 2562 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2564 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_276 (insn, operands);

    case 2:
      if (!(
#line 3201 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3203 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_309 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return NULL;
  operands[2] = x3;
  if (pattern164 (x1) == 0
      && 
#line 5024 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
    return gen_split_396 (insn, operands);
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (XWINT (x3, 0))
    {
    case 1L:
      switch (pattern202 (x2))
        {
        case 0:
          if (!
#line 5097 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_397 (insn, operands);

        case 1:
          if (!
#line 5139 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_399 (insn, operands);

        case 2:
          if (!
#line 5181 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_401 (insn, operands);

        default:
          return NULL;
        }

    case 15L:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !
#line 5118 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_398 (insn, operands);

    case 23L:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x2) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !
#line 5160 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_400 (insn, operands);

    case 31L:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !
#line 5202 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_402 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern23 (x1))
    {
    case 0:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1411 (insn, operands);

    case 1:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1412 (insn, operands);

    case 2:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1413 (insn, operands);

    case 3:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1414 (insn, operands);

    case 4:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1415 (insn, operands);

    case 5:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1416 (insn, operands);

    case 6:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1417 (insn, operands);

    case 7:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1418 (insn, operands);

    case 8:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1419 (insn, operands);

    case 9:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1420 (insn, operands);

    case 10:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1421 (insn, operands);

    case 11:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1422 (insn, operands);

    case 12:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1423 (insn, operands);

    case 13:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1424 (insn, operands);

    case 14:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1425 (insn, operands);

    case 15:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1426 (insn, operands);

    case 16:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1427 (insn, operands);

    case 17:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1428 (insn, operands);

    case 18:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != QQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1429 (insn, operands);

    case 19:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1430 (insn, operands);

    case 20:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1431 (insn, operands);

    case 21:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1432 (insn, operands);

    case 22:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1433 (insn, operands);

    case 23:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1434 (insn, operands);

    case 24:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1435 (insn, operands);

    case 25:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1436 (insn, operands);

    case 26:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1437 (insn, operands);

    case 27:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1438 (insn, operands);

    case 28:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1439 (insn, operands);

    case 29:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1440 (insn, operands);

    case 30:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1441 (insn, operands);

    case 31:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1442 (insn, operands);

    case 32:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1443 (insn, operands);

    case 33:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1444 (insn, operands);

    case 34:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1445 (insn, operands);

    case 35:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1446 (insn, operands);

    case 36:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1447 (insn, operands);

    case 37:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UQQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1448 (insn, operands);

    case 38:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1449 (insn, operands);

    case 39:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1450 (insn, operands);

    case 40:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1451 (insn, operands);

    case 41:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1452 (insn, operands);

    case 42:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1453 (insn, operands);

    case 43:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1454 (insn, operands);

    case 44:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1455 (insn, operands);

    case 45:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1456 (insn, operands);

    case 46:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1457 (insn, operands);

    case 47:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1458 (insn, operands);

    case 48:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1459 (insn, operands);

    case 49:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1460 (insn, operands);

    case 50:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1461 (insn, operands);

    case 51:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1462 (insn, operands);

    case 52:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1463 (insn, operands);

    case 53:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1464 (insn, operands);

    case 54:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1465 (insn, operands);

    case 55:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1466 (insn, operands);

    case 56:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != HQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1467 (insn, operands);

    case 57:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1468 (insn, operands);

    case 58:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1469 (insn, operands);

    case 59:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1470 (insn, operands);

    case 60:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1471 (insn, operands);

    case 61:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1472 (insn, operands);

    case 62:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1473 (insn, operands);

    case 63:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1474 (insn, operands);

    case 64:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1475 (insn, operands);

    case 65:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1476 (insn, operands);

    case 66:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1477 (insn, operands);

    case 67:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1478 (insn, operands);

    case 68:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1479 (insn, operands);

    case 69:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1480 (insn, operands);

    case 70:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1481 (insn, operands);

    case 71:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1482 (insn, operands);

    case 72:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1483 (insn, operands);

    case 73:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1484 (insn, operands);

    case 74:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1485 (insn, operands);

    case 75:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UHQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1486 (insn, operands);

    case 76:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1487 (insn, operands);

    case 77:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1488 (insn, operands);

    case 78:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1489 (insn, operands);

    case 79:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1490 (insn, operands);

    case 80:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1491 (insn, operands);

    case 81:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1492 (insn, operands);

    case 82:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1493 (insn, operands);

    case 83:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1494 (insn, operands);

    case 84:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1495 (insn, operands);

    case 85:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1496 (insn, operands);

    case 86:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1497 (insn, operands);

    case 87:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1498 (insn, operands);

    case 88:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1499 (insn, operands);

    case 89:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1500 (insn, operands);

    case 90:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1501 (insn, operands);

    case 91:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1502 (insn, operands);

    case 92:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1503 (insn, operands);

    case 93:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1504 (insn, operands);

    case 94:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != HAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1505 (insn, operands);

    case 95:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1506 (insn, operands);

    case 96:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1507 (insn, operands);

    case 97:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1508 (insn, operands);

    case 98:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1509 (insn, operands);

    case 99:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1510 (insn, operands);

    case 100:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1511 (insn, operands);

    case 101:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1512 (insn, operands);

    case 102:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1513 (insn, operands);

    case 103:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1514 (insn, operands);

    case 104:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1515 (insn, operands);

    case 105:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1516 (insn, operands);

    case 106:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1517 (insn, operands);

    case 107:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1518 (insn, operands);

    case 108:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1519 (insn, operands);

    case 109:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1520 (insn, operands);

    case 110:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1521 (insn, operands);

    case 111:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1522 (insn, operands);

    case 112:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1523 (insn, operands);

    case 113:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UHAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1524 (insn, operands);

    case 114:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1525 (insn, operands);

    case 115:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1526 (insn, operands);

    case 116:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1527 (insn, operands);

    case 117:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1528 (insn, operands);

    case 118:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1529 (insn, operands);

    case 119:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1530 (insn, operands);

    case 120:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1531 (insn, operands);

    case 121:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1532 (insn, operands);

    case 122:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1533 (insn, operands);

    case 123:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1534 (insn, operands);

    case 124:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1535 (insn, operands);

    case 125:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1536 (insn, operands);

    case 126:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1537 (insn, operands);

    case 127:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1538 (insn, operands);

    case 128:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1539 (insn, operands);

    case 129:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1540 (insn, operands);

    case 130:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1541 (insn, operands);

    case 131:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1542 (insn, operands);

    case 132:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != SQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1543 (insn, operands);

    case 133:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1544 (insn, operands);

    case 134:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1545 (insn, operands);

    case 135:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1546 (insn, operands);

    case 136:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1547 (insn, operands);

    case 137:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1548 (insn, operands);

    case 138:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1549 (insn, operands);

    case 139:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1550 (insn, operands);

    case 140:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1551 (insn, operands);

    case 141:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1552 (insn, operands);

    case 142:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1553 (insn, operands);

    case 143:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1554 (insn, operands);

    case 144:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1555 (insn, operands);

    case 145:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1556 (insn, operands);

    case 146:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1557 (insn, operands);

    case 147:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1558 (insn, operands);

    case 148:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1559 (insn, operands);

    case 149:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1560 (insn, operands);

    case 150:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1561 (insn, operands);

    case 151:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != USQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1562 (insn, operands);

    case 152:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1563 (insn, operands);

    case 153:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1564 (insn, operands);

    case 154:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1565 (insn, operands);

    case 155:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1566 (insn, operands);

    case 156:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1567 (insn, operands);

    case 157:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1568 (insn, operands);

    case 158:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1569 (insn, operands);

    case 159:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1570 (insn, operands);

    case 160:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1571 (insn, operands);

    case 161:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1572 (insn, operands);

    case 162:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1573 (insn, operands);

    case 163:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1574 (insn, operands);

    case 164:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1575 (insn, operands);

    case 165:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1576 (insn, operands);

    case 166:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1577 (insn, operands);

    case 167:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1578 (insn, operands);

    case 168:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1579 (insn, operands);

    case 169:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1580 (insn, operands);

    case 170:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != SAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1581 (insn, operands);

    case 171:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1582 (insn, operands);

    case 172:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1583 (insn, operands);

    case 173:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1584 (insn, operands);

    case 174:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1585 (insn, operands);

    case 175:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1586 (insn, operands);

    case 176:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1587 (insn, operands);

    case 177:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1588 (insn, operands);

    case 178:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1589 (insn, operands);

    case 179:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1590 (insn, operands);

    case 180:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1591 (insn, operands);

    case 181:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1592 (insn, operands);

    case 182:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1593 (insn, operands);

    case 183:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1594 (insn, operands);

    case 184:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1595 (insn, operands);

    case 185:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1596 (insn, operands);

    case 186:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1597 (insn, operands);

    case 187:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1598 (insn, operands);

    case 188:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1599 (insn, operands);

    case 189:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != USAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1600 (insn, operands);

    case 190:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1601 (insn, operands);

    case 191:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1602 (insn, operands);

    case 192:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1603 (insn, operands);

    case 193:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1604 (insn, operands);

    case 194:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1605 (insn, operands);

    case 195:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1606 (insn, operands);

    case 196:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1607 (insn, operands);

    case 197:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1608 (insn, operands);

    case 198:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1609 (insn, operands);

    case 199:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1610 (insn, operands);

    case 200:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1611 (insn, operands);

    case 201:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1612 (insn, operands);

    case 202:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1613 (insn, operands);

    case 203:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1614 (insn, operands);

    case 204:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1615 (insn, operands);

    case 205:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1616 (insn, operands);

    case 206:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1617 (insn, operands);

    case 207:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1618 (insn, operands);

    case 208:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != DQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1619 (insn, operands);

    case 209:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1620 (insn, operands);

    case 210:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1621 (insn, operands);

    case 211:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1622 (insn, operands);

    case 212:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1623 (insn, operands);

    case 213:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1624 (insn, operands);

    case 214:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1625 (insn, operands);

    case 215:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1626 (insn, operands);

    case 216:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1627 (insn, operands);

    case 217:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1628 (insn, operands);

    case 218:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1629 (insn, operands);

    case 219:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1630 (insn, operands);

    case 220:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1631 (insn, operands);

    case 221:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1632 (insn, operands);

    case 222:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1633 (insn, operands);

    case 223:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1634 (insn, operands);

    case 224:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1635 (insn, operands);

    case 225:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1636 (insn, operands);

    case 226:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1637 (insn, operands);

    case 227:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UDQmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1638 (insn, operands);

    case 228:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1639 (insn, operands);

    case 229:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1640 (insn, operands);

    case 230:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1641 (insn, operands);

    case 231:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1642 (insn, operands);

    case 232:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1643 (insn, operands);

    case 233:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1644 (insn, operands);

    case 234:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1645 (insn, operands);

    case 235:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1646 (insn, operands);

    case 236:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1647 (insn, operands);

    case 237:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1648 (insn, operands);

    case 238:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1649 (insn, operands);

    case 239:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1650 (insn, operands);

    case 240:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1651 (insn, operands);

    case 241:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1652 (insn, operands);

    case 242:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1653 (insn, operands);

    case 243:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1654 (insn, operands);

    case 244:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1655 (insn, operands);

    case 245:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1656 (insn, operands);

    case 246:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != DAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1657 (insn, operands);

    case 247:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1658 (insn, operands);

    case 248:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1659 (insn, operands);

    case 249:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1660 (insn, operands);

    case 250:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1661 (insn, operands);

    case 251:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1662 (insn, operands);

    case 252:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1663 (insn, operands);

    case 253:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1664 (insn, operands);

    case 254:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1665 (insn, operands);

    case 255:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1666 (insn, operands);

    case 256:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1667 (insn, operands);

    case 257:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1668 (insn, operands);

    case 258:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1669 (insn, operands);

    case 259:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1670 (insn, operands);

    case 260:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1671 (insn, operands);

    case 261:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1672 (insn, operands);

    case 262:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1673 (insn, operands);

    case 263:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1674 (insn, operands);

    case 264:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1675 (insn, operands);

    case 265:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UDAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1676 (insn, operands);

    case 266:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1677 (insn, operands);

    case 267:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1678 (insn, operands);

    case 268:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1679 (insn, operands);

    case 269:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1680 (insn, operands);

    case 270:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1681 (insn, operands);

    case 271:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1682 (insn, operands);

    case 272:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1683 (insn, operands);

    case 273:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1684 (insn, operands);

    case 274:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1685 (insn, operands);

    case 275:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1686 (insn, operands);

    case 276:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1687 (insn, operands);

    case 277:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1688 (insn, operands);

    case 278:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1689 (insn, operands);

    case 279:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1690 (insn, operands);

    case 280:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1691 (insn, operands);

    case 281:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1692 (insn, operands);

    case 282:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1693 (insn, operands);

    case 283:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1694 (insn, operands);

    case 284:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != TAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1695 (insn, operands);

    case 285:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1696 (insn, operands);

    case 286:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1697 (insn, operands);

    case 287:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1698 (insn, operands);

    case 288:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1699 (insn, operands);

    case 289:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1700 (insn, operands);

    case 290:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1701 (insn, operands);

    case 291:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1702 (insn, operands);

    case 292:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1703 (insn, operands);

    case 293:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1704 (insn, operands);

    case 294:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1705 (insn, operands);

    case 295:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1706 (insn, operands);

    case 296:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1707 (insn, operands);

    case 297:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1708 (insn, operands);

    case 298:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1709 (insn, operands);

    case 299:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1710 (insn, operands);

    case 300:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1711 (insn, operands);

    case 301:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1712 (insn, operands);

    case 302:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1713 (insn, operands);

    case 303:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UTAmode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1714 (insn, operands);

    case 304:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1715 (insn, operands);

    case 305:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1716 (insn, operands);

    case 306:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1717 (insn, operands);

    case 307:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1718 (insn, operands);

    case 308:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1719 (insn, operands);

    case 309:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1720 (insn, operands);

    case 310:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1721 (insn, operands);

    case 311:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1722 (insn, operands);

    case 312:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1723 (insn, operands);

    case 313:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1724 (insn, operands);

    case 314:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1725 (insn, operands);

    case 315:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1726 (insn, operands);

    case 316:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1727 (insn, operands);

    case 317:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1728 (insn, operands);

    case 318:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1729 (insn, operands);

    case 319:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1730 (insn, operands);

    case 320:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1731 (insn, operands);

    case 321:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1732 (insn, operands);

    case 322:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != QImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1733 (insn, operands);

    case 323:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1734 (insn, operands);

    case 324:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1735 (insn, operands);

    case 325:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1736 (insn, operands);

    case 326:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1737 (insn, operands);

    case 327:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1738 (insn, operands);

    case 328:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1739 (insn, operands);

    case 329:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1740 (insn, operands);

    case 330:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1741 (insn, operands);

    case 331:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1742 (insn, operands);

    case 332:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1743 (insn, operands);

    case 333:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1744 (insn, operands);

    case 334:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1745 (insn, operands);

    case 335:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1746 (insn, operands);

    case 336:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1747 (insn, operands);

    case 337:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1748 (insn, operands);

    case 338:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1749 (insn, operands);

    case 339:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1750 (insn, operands);

    case 340:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1751 (insn, operands);

    case 341:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != HImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1752 (insn, operands);

    case 342:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1753 (insn, operands);

    case 343:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1754 (insn, operands);

    case 344:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1755 (insn, operands);

    case 345:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1756 (insn, operands);

    case 346:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1757 (insn, operands);

    case 347:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1758 (insn, operands);

    case 348:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1759 (insn, operands);

    case 349:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1760 (insn, operands);

    case 350:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1761 (insn, operands);

    case 351:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1762 (insn, operands);

    case 352:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1763 (insn, operands);

    case 353:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1764 (insn, operands);

    case 354:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1765 (insn, operands);

    case 355:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1766 (insn, operands);

    case 356:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1767 (insn, operands);

    case 357:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1768 (insn, operands);

    case 358:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1769 (insn, operands);

    case 359:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1770 (insn, operands);

    case 360:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != SImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1771 (insn, operands);

    case 361:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1772 (insn, operands);

    case 362:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1773 (insn, operands);

    case 363:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1774 (insn, operands);

    case 364:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1775 (insn, operands);

    case 365:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1776 (insn, operands);

    case 366:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1777 (insn, operands);

    case 367:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1778 (insn, operands);

    case 368:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1779 (insn, operands);

    case 369:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1780 (insn, operands);

    case 370:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1781 (insn, operands);

    case 371:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1782 (insn, operands);

    case 372:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1783 (insn, operands);

    case 373:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1784 (insn, operands);

    case 374:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1785 (insn, operands);

    case 375:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1786 (insn, operands);

    case 376:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1787 (insn, operands);

    case 377:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1788 (insn, operands);

    case 378:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1789 (insn, operands);

    case 379:
      if (!(
#line 86 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != DImode) && 
#line 88 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1790 (insn, operands);

    default:
      return NULL;
    }
}
